function [A,B,B1,P,c,y,g,i] = RBCsolve(rho,D,pi,muzstar,beta,tauD,tauk,upsil,delta,lambdaf,alpha,b,taul,tauc, ...
                    lambdaw,zeta,psiL,etag,Sdoupr,sigmaa,sigmaL,taushock,parstoch,accuracy,static,etai,util)

lambdaf=1;
lambdaw=1;
tauk=0;
taul=0;
tauc=0;
etag=0;
upsil=1;

%steadystate
pi=1;
RT=( (muzstar*pi/beta)-1 )* (1/(1-tauD));
Rk=RT*(1-tauD);
q=1;
u=1;
rk= upsil*Rk/( (1-tauk)*pi ) - (1-delta)/(1-tauk) - upsil*tauk*delta/((1-tauk)*pi)  + upsil/((1-tauk)*pi);
w=( (1/lambdaf) * ((1/(1-alpha))^(alpha-1)) * ((1/alpha)^(-alpha)) * rk^(-alpha) )^(1/(1-alpha));

num= w*(muzstar-b*beta)*(1-taul) /(muzstar-b);
den1= (1+tauc)*lambdaw*zeta*psiL;
den2= (1-etag)*(1/lambdaf)*(w*alpha/(rk*(1-alpha)))^alpha;
den3= (w*alpha*upsil*muzstar/(rk*(1-alpha)))*(1-(1-delta)/(muzstar*upsil));
l=( num / (den1*(den2-den3)) )^(1/(1+sigmaL));

k= w*alpha*upsil*muzstar*l / (rk*(1-alpha));
i= k*(1-(1-delta)/(muzstar*upsil));
y= (1/lambdaf) * ((k/(muzstar*upsil))^alpha) * l^(1-alpha);
c= (1-etag)*y-i;
lamz= ( 1/(c*(1+tauc)) ) * (muzstar-b*beta)/(muzstar-b);
phi= ((k/(upsil*muzstar))^alpha) * (l^(1-alpha)) * (1-(1/lambdaf));
uzc= (1+tauc)*lamz;
a_prime=rk;
g=etag*y;

%list of variables
% 1) rk(t)
% 2) l(t)
% 3) i(t)
% 4) u(t)
% 5) uzc(t)
% 6) RT(t)
% 7) Rk(t)
% 8) q(t)
% 9) lamz(t)
% 10) w(t)
% 11) c(t)
% 12) k(t+1)

% Linearised equations
alpha_0=zeros(12,12);
alpha_1=zeros(12,12);
alpha_2=zeros(12,12);
beta_0=zeros(12,24);
beta_1=zeros(12,24);

%
alpha_1(1,1) = alpha;
alpha_1(1,10)  = 1-alpha;

beta_1(1,1)  = 1;
beta_1(1,18) = -1;

%
alpha_1(2,1)  = 1; %rk
alpha_1(2,2)  = -(1-alpha); %l
alpha_1(2,4)  = (1-alpha); %u

alpha_2(2,12)  = (1-alpha); %k

beta_1(2,1) = 1;
beta_1(2,18)=-1;
beta_1(2,16)=-(1-alpha);

%

if static ==0
    alpha_0(3,3)  = beta*Sdoupr*(muzstar*upsil)^2;
    
    alpha_1(3,8)  = 1;
    alpha_1(3,3)  = -Sdoupr*(1+beta)*(muzstar*upsil)^2; 
    
    alpha_2(3,3) = Sdoupr*(muzstar*upsil)^2;
    
    beta_0(3,16) = beta*Sdoupr*(muzstar*upsil)^2;
    beta_0(3,23) = beta*Sdoupr*(muzstar*upsil)^2;
    
    beta_1(3,7)  = 1;
    beta_1(3,16) = -Sdoupr*(muzstar*upsil)^2;
    beta_1(3,23) = -Sdoupr*(muzstar*upsil)^2;
    
elseif static ==1
    
    alpha_1(3,3)  = -1/etai;
    alpha_1(3,8)  = 1;
    
    alpha_2(3,12)  = 1/etai;
    
    beta_1(3,7) = 1;
    beta_1(3,16) = -1/etai;
end

%
%alpha_1(4,1)  = 1;
%alpha_1(4,4)  = -sigmaa;

if util ==1
    alpha_1(4,1)    =   1/sigmaa;
    beta_1(4,24)    =   -1/sigmaa;
elseif util == 0
    alpha_1(4,1)    =   0;
end    
alpha_1(4,4)    =   -1;

%
alpha_0(5,11)  = -c*b*beta*muzstar / ( (c^2)*(muzstar-b)^2 ) ;

alpha_1(5,5)  = uzc;
alpha_1(5,11)  = c*( (muzstar^2)+beta*(b^2) ) / ( (c^2)*(muzstar-b)^2 ) ;

alpha_2(5,11)  = - c*b*muzstar / ( (c^2)*(muzstar-b)^2 );

beta_0(5,16) = -b*beta*muzstar*c / ( (c^2)*(muzstar-b)^2);
beta_0(5,22) = b*beta/(c*(muzstar-b));

beta_1(5,16) = -muzstar/(c*(muzstar-b)) +c*muzstar^2/( (c^2)*(muzstar-b)^2);
beta_1(5,22) =   -muzstar/(c*(muzstar-b));

%
alpha_0(6,9)  = 1;

alpha_1(6,9)  = -1;
alpha_1(6,6)  = RT*(1-tauD) / (1+(1-tauD)*RT);

beta_0(6,16)  = -1;
beta_0(6,15)  = -RT*tauD/( 1+(1-tauD)*RT);
beta_0(6,22)  = 1;

beta_1(6,22)  = -1;
%
alpha_0(7,7)  = Rk / (1+Rk);
alpha_0(7,9)  = 1;

alpha_1(7,9)  = -1;

beta_0(7,16)  = -1;
beta_0(7,22)  = 1;

beta_1(7,22)  = -1;

%
alpha_1(8,7)  = 1;
alpha_1(8,1)  = -pi*(1-tauk)*rk /(upsil*Rk*q);
if static ==0
    alpha_1(8,8)  = -(1-delta)*pi*q/(upsil*Rk*q);
elseif static ==1
    alpha_1(8,8)  = -pi*muzstar/Rk;
end

alpha_2(8,8)  = ( (1-tauk)*rk*pi +(1-delta)*q*pi )/(upsil*Rk*q);

beta_1(8,11) = (rk*pi-delta*upsil*q)*tauk/(q*upsil*Rk); %this is the coefficient on tauk(t-1) and not on tauk(t) which should instead be zero. We accommodate it below when expanding the betas
if static ==1
    beta_1(8,7) = -muzstar*(i/k)/Rk;
end
%
alpha_1(9,5)  = uzc;
alpha_1(9,9)  = -(1+tauc)*lamz;

beta_1(9,20)  = -tauc*lamz;
beta_1(9,22)  = -(1+tauc)*lamz;
%beta_1(9,24)  = -(1+tauc)*lamz;This term was inserted in
%order to allow for an impact of an energy price shock on consumpion

%
alpha_1(10,10)  = 1;
alpha_1(10,2)  = -sigmaL;
alpha_1(10,9)  = 1;

beta_1(10,10)  = -taul/(1-taul);
beta_1(10,12)  = -1;

%
u_y = (a_prime*k/(muzstar*upsil))/(y+phi);
c_y = c/(y+phi);
g_y = g/(y+phi);
k_y = k/(y+phi);

alpha_1(11,4)  = u_y -alpha;
alpha_1(11,11) = c_y;
alpha_1(11,3)   = k_y*i/k;
alpha_1(11,2)  =-(1-alpha);

alpha_2(11,12)  = -alpha;

%beta_1(11,24) = c_y;This term was inserted in
%order to allow for an impact of an energy price shock on consumpion
beta_1(11,7) = -k_y*i/k;
beta_1(11,13)  = g_y;
beta_1(11,16)  = alpha;
beta_1(11,18)=-1;

%
alpha_1(12,12)  = 1;
alpha_1(12,3)  = -i/k;

alpha_2(12,12)  = -(1-delta)/(muzstar*upsil);

beta_1(12,16) = (1-delta)/(muzstar*upsil);

%%%%%%%%%%%%
%expand the betas to take into account the ARMA(2,n) structure of the shocks
betaM_0 = beta_0;
betaM_1 = beta_1;

b_0j=[];
beta_0=[];
b_1j=[];
beta_1=[];
for ii=1:size(betaM_0,1)
    for j=1:length(taushock)
        taux    = zeros(1,parstoch(taushock(j))+2);
        taux(1) = 1; 
        
        bb0 =betaM_0(ii,taushock(j))*taux;
        b_0j =[b_0j, bb0];
        
        if taushock(j)==11 & ii==8
            taux    = zeros(1,parstoch(taushock(j))+2);
            taux(2) = 1; 
        else
            taux    = zeros(1,parstoch(taushock(j))+2);
            taux(1) = 1; 
        end
        
        bb1 =betaM_1(ii,taushock(j))*taux;
        b_1j =[b_1j, bb1];
    end
    beta_0 = [beta_0; b_0j];
    b_0j=[];
    
    beta_1 = [beta_1; b_1j];
    b_1j=[];    
end

%%%%%%%%%
alphas=[alpha_0 alpha_1 alpha_2];
betas=[beta_0 beta_1];

%
taumat  = ones(size(beta_0)); %you see everything.
taumat   =   taumat';
%

[A] = findandcheckA(alphas,alpha_2,alpha_1,alpha_0,accuracy);

[B,P]   =   solveb(A,alphas,betas,rho,taumat);
if size(P,1) ==  size(rho,1)
    P = [rho, zeros(size(rho,1),size(rho,1)); eye(size(rho,1)), zeros(size(rho,1),size(rho,1))];
    B1 = real(B);
    B2 = zeros(size(A,1),size(rho,1));
    B  = [B1 B2];
else
    B1 = real(B(:,1:size(rho,1)));
    B2 = real(B(:,size(rho,1)+1:end));
end;

if max(max(abs(imag(A)))) > 1e-12
    error('fatal (solvemodel) A complex')
end
if max(max(abs(imag(B)))) > 2e-12
    error('fatal (solvemodel) B complex')
end

A=real(A);
B=real(B);
