function [] = autocov(outfolder,entr,Xdat,initV,RR,H,F,Q,V_eps,B1,D,alf,is,init_kalman,ric,categ,tauvar,fdiff,demean,k,p,N,display_cov,lambda_hp,taushock,parstoch,l_psi,shockss)
%Compute autocovariances in the time and/or frequency domain for the model and the data

keyboard; demean=0;

t100 = 100; %results in the plot are multiplied by t100^2 in order to get the results we would get if the data were in percent; otherwise set it to 1.
            %if display_cov=0, t100 will be set automatically to 1
init_kalman_switch = 1; %=1, empirical autocovariances are computed using sample starting in init_kalman-k+1; =2, starting in init_kalman+1

chkRieman = 1; %=1,some sort of check on the Riemann approximation to the integral
YWcheck   = 1; %=1, verifies that the Yule-Walker equations have been accurately solved
tol_err = 10^-10;

pp = [1,2,3,4,5,12]; %it will compute VAR representation for alternative values of p
k1 = k; %autocovariances are displayed up to order k1


%---- start computations
if max(pp==p) ~= 1
    pp = sort([pp p]);
end

k = max(pp); %to construct VAR_implied of order p we need autocovariances of at least order p

if display_cov ==0
    t100=1;
end

%--- transform variables
% index_trans = {5,  1,  1,  'Y';    %1st column specifies the variables you want to analyse (numbering refers to full list of variables, not tauvar). Put in first row the variable you want to be displayed first in the chart with autocovariances, and so on. You can also have linear combinations, eg: [1 -3], [0 1],[1 1], 'name'
%                10, 1,  1,  'C';    %2nd column specifies transformation you want to make on the observable variable. =0, do nothing; =1, convert to level; =2, convert to first difference
%                7,  1,  1,  'I';    %3rd column specifies whether you want to apply the HP filter. =0, do nothing; =1, apply filter. The filter is applied on the variable transformed as indicated in the 2nd column
%               % 3,  0,  1,  'H';    %2nd and 3rd columns must have the same number of entries of column 1
%                2,  0,  1,  'dP';
%                11, 0,  1,  'Pe';
%                4,  1,  1,  'L';
%                1,  1,  1,  'N'};

index_trans = {5,  0,  0,  'dY';    %1st column specifies the variables you want to analyse (numbering refers to full list of variables, not tauvar). Put in first row the variable you want to be displayed first in the chart with autocovariances, and so on. You can also have linear combinations, eg: [1 -3], [0 1],[1 1], 'name'
               10, 0,  0,  'dC';    %2nd column specifies transformation you want to make on the observable variable. =0, do nothing; =1, convert to level; =2, convert to first difference
               7,  0,  0,  'dI';    %3rd column specifies whether you want to apply the HP filter. =0, do nothing; =1, apply filter. The filter is applied on the variable transformed as indicated in the 2nd column
               %3,  0,  0,  'H';    %2nd and 3rd columns must have the same number of entries of column 1
               2,  0,  0,  'dP';
               11, 0,  0,  'Pe';
               4,  0,  0,  'dL';
               1,  0,  0,  'dN'};


%drop variables (listed in first column of index_trans) that are not
%included in tauvar, and re-number entries to reflect size of tauvar. Finally, construct a selection matrix JJ
JJ = zeros(1,size(tauvar,2)); %it will be expanded below. At this point we don't know yet the number the rows it will finally have
index_do_trans = 0;
index_do_hp = 0;
ii = 1;
for jj = 1:size(index_trans,1)
    rob = index_trans{jj,1};
    ij__ = [];
    for ij = 1:size(rob,2)
      rob__ = tauvar==abs(rob(1,ij));
      if max(rob__) == 1
          ij__ = [ij__  sign(rob(1,ij))*find(rob__)];
      end
    end
    if length(ij__) == ij
        index_{ii,1} = ij__;
        index_(ii,2) = index_trans(jj,2);
        index_(ii,3) = index_trans(jj,3);
        index_(ii,4) = index_trans(jj,4);
        
        JJ(ii,abs(ij__)) = sign(ij__);
        ii = ii +1;
        
        index_do_trans = index_do_trans + sum(index_{jj,2});
        index_do_hp = index_do_hp + sum(index_{jj,3});
    end
end


%-----------------------------------------------------------------------
%-----  Model-implied autocovariances
%-----------------------------------------------------------------------

Nvar = length(tauvar); 
Nvar_c = size(index_,1);

%--- (1) Time domain --we do it if we do not need to transform variables (e.g. differencing of variables) or to apply the HP filter. In these cases we compute autocovariances in the frequency domain only
if index_do_trans==0 && index_do_hp ==0
    
    Ey = alf;

    if ric ==0
        [initV_dare]  =   dare(F',zeros(size(F)),Q);
        if max(max(abs( initV_dare - F*initV_dare*F' - Q ))) > .1e-8
            error('fatal (autocov) failed to solve Riccati Equation')
        end
        initV = initV_dare;
    end

    C0 = JJ*H*initV*H'*JJ' + JJ*RR*JJ' + JJ*Ey*Ey'*JJ';

    Ck_t = zeros(Nvar_c,Nvar_c,k+1);

    Ck_t(:,:,1) = C0;

    for kk=1:k
        Ck_t(:,:,kk+1) = JJ*H*(F^kk*initV)*H'*JJ' +  JJ*Ey*Ey'*JJ';
    end
end

%--- (2) Frequency domain
NN = N/2;

om = 2*pi*[(1:NN+1)-1]/N;

z = exp(-sqrt(-1)*om);

[g1,g2] = HPSPECT(lambda_hp);

fz = (-g2*(1-z).*(1-z).*(1-1./z).*(1-1./z)./((1-g1*z-g2*z.^2).*(1-g1./z-g2./z.^2))); %apply HP
fztil = (-g2*(1-z).*(1-1./z).*(1-1./z)./((1-g1*z-g2*z.^2).*(1-g1./z-g2./z.^2))); %convert to level and apply HP


GG = [B1*D; zeros(size(B1*D)); D];
if is ==1
    GG = [GG; zeros(size(D))];
end

Spec = zeros(Nvar_c,Nvar_c,length(z));
Spec_full = zeros(Nvar,Nvar,length(z)); %we do it because we will use it in solving the Yule-walker equations
Spec_jj = zeros(Nvar_c,Nvar_c,length(z),size(V_eps,1)+1);
Spec_categ = zeros(Nvar_c,Nvar_c,length(z),size(categ,1)); %+1); %we leave out the measurement error

for ii = 1:length(z)
    JJj = JJ;

    zz = z(ii);

    %transform variables as specified in 2nd and 3rd columns of index_
    for jkj = 1:size(index_,1)
        rob1 = index_{jkj,1};
        rob2 = index_{jkj,2};
        rob3 = index_{jkj,3};

        for iki = 1:size(rob1,2)

            if rob2(iki) ==0 && rob3(iki)==0
                ff_ = 1;
            elseif rob2(iki) == 2 && rob3(iki)==0
                ff_ = 1-zz;
            elseif rob2(iki) ==0 && rob3(iki)==1
                ff_ = fz(ii);
            elseif rob2(iki) ==2 && rob3(iki)==1
                error('you have chosen to transform a variable in first difference and to apply HP filter on that transformed variable. This makes little sense')
            elseif rob2(iki) ==1 && rob3(iki)==1
                ff_ = fztil(ii);
            elseif rob2(iki) ==1 && rob3(iki)==0
                error('you have chosen to transform a variable in level and do not want to apply HP filter on that transformed variable. This is not defined at omega=0')
            end

            JJj(jkj,rob1(iki)) = JJ(jkj,rob1(iki))*ff_;
        end
    end

    S_y = H*inv(eye(size(F)) - F*zz);
    
    DRD = RR;
    
    Spec(:,:,ii) = JJj*S_y*Q*S_y'*JJj' + JJj*DRD*JJj';
    Spec_full(:,:,ii) = S_y*Q*S_y' + DRD;
    
   
    %do it shock by shock
    checkjj = zeros(size(Spec,1),size(Spec,1));
    for jj = 1:size(V_eps,1)
                
        qq = zeros(1,length(V_eps));
        qq(jj) = V_eps(jj,jj);
        VV_eps = diag(qq);
        
        QQ = GG*VV_eps*GG';
                
        Spec_jj(:,:,ii,jj) = JJj*S_y*QQ*S_y'*JJj'; 
        checkjj = checkjj + Spec_jj(:,:,ii,jj);
    end    
    Spec_jj(:,:,ii,jj+1) = JJj*DRD*JJj';
    
    if max(max(checkjj+JJj*DRD*JJj' - Spec(:,:,ii))) >1.e-10; 
        error('fatal, sum of individual shock contributions to variance does not not sum up to total');
    end
    
    %do it category by category of shocks
    for jk = 1:size(categ,1)
        qq = zeros(1,length(V_eps));
        qq(categ{jk,2}) = diag(V_eps(categ{jk,2},categ{jk,2}));
        VV_eps = diag(qq);
        
        QQ = GG*VV_eps*GG';
                
        Spec_categ(:,:,ii,jk) = JJj*S_y*QQ*S_y'*JJj'; 
    end
    %Spec_categ(:,:,ii,jk+1) = JJj*DRD*JJj';   
        
end


%Compute the autocovariances C(0),C(1),...,C(k) exploting some properties (see technical appendix)
%Save in Ck_f(:,:,1)=C(0), ... Ck_f(:,:,k+1) = C(k)
Ck_f = zeros(Nvar_c,Nvar_c,k+1);
Ck_f_full = zeros(Nvar,Nvar,k+1);
Ck_f_jj = zeros(Nvar_c,Nvar_c,k+1,size(Spec_jj,4));
Ck_f_categ = zeros(Nvar_c,Nvar_c,k+1,size(Spec_categ,4));

if max(max(abs(imag(Spec(:,:,1))))) || max(max(max(abs(imag(Spec_jj(:,:,1,:))))))  || max(max(max(abs(imag(Spec_categ(:,:,1,:)))))) > .1e-9
    error('fatal Spectral density at omega=0 is complex')
end

for kkk = 1:k+1
    
    Ck_f(:,:,kkk) = real(Spec(:,:,1)); %the imaginary part should be 0 in theory
    Ck_f_full(:,:,kkk) = real(Spec_full(:,:,1));
    Ck_f_jj(:,:,kkk,:) = real(Spec_jj(:,:,1,:));
    Ck_f_categ(:,:,kkk,:) = real(Spec_categ(:,:,1,:));
    
    for jjj = 2:NN
        w = (pi*(jjj-1))/NN;
        Ck_f(:,:,kkk) = Ck_f(:,:,kkk) + 2*real(Spec(:,:,jjj)*exp(sqrt(-1)*w*(kkk-1)));
        Ck_f_full(:,:,kkk) = Ck_f_full(:,:,kkk) + 2*real(Spec_full(:,:,jjj)*exp(sqrt(-1)*w*(kkk-1)));
        Ck_f_jj(:,:,kkk,:) = Ck_f_jj(:,:,kkk,:) + 2*real(Spec_jj(:,:,jjj,:)*exp(sqrt(-1)*w*(kkk-1)));
        Ck_f_categ(:,:,kkk,:) = Ck_f_categ(:,:,kkk,:) + 2*real(Spec_categ(:,:,jjj,:)*exp(sqrt(-1)*w*(kkk-1)));
    end
    Ck_f(:,:,kkk) = (Ck_f(:,:,kkk) + real(Spec(:,:,NN+1)*exp(sqrt(-1)*pi*(kkk-1))))/(2*NN);
    Ck_f_full(:,:,kkk) = (Ck_f_full(:,:,kkk) + real(Spec_full(:,:,NN+1)*exp(sqrt(-1)*pi*(kkk-1))))/(2*NN);
    Ck_f_jj(:,:,kkk,:) = (Ck_f_jj(:,:,kkk,:) + real(Spec_jj(:,:,NN+1,:)*exp(sqrt(-1)*pi*(kkk-1))))/(2*NN);
    Ck_f_categ(:,:,kkk,:) = (Ck_f_categ(:,:,kkk,:) + real(Spec_categ(:,:,NN+1,:)*exp(sqrt(-1)*pi*(kkk-1))))/(2*NN);
end

%the check below computes autocovariances integrating the spectrum between -pi and pi
%this provides a check on the computations above
if chkRieman == 1
    checkRieman(k,Nvar_c,Spec,Ck_f,NN,tol_err)
end

%check whether autocovariances computed in time and frequency domain are equal
if index_do_trans ==0 && index_do_hp ==0
if max(max(max(max(Ck_t - Ck_f)))) > tol_err
    error(['fatal autocovariances computed in time and frequency domain differ by more than ' num2str(tol_err)] )
end
end

Ck_m = Ck_f; %define CK_m as autocovariances implied by the model

%unload the results
CCk_m = zeros(1,k+1,Nvar_c,Nvar_c);
for ii = 1:Nvar_c
    for jj = 1:Nvar_c
        for kk = 1:k+1
            KK_(kk) = Ck_m(ii,jj,kk);
        end
        CCk_m(:,:,ii,jj) = KK_;
    end
end

if display_cov == 0
    CCk_m = cov_to_corr(CCk_m);
end


%-------------------------------------------------------------------------
%-----  VAR(p) representation of the model
%-------------------------------------------------------------------------

%-- using the autocovariances computed above, solve the Yule-Walker equations
if k<p
    error('fatal lag-order you selected for VAR representation of the model is > than max order of autocovariances you selected. Increase autocov order')
end


CCk_var_pp = zeros(Nvar_c,Nvar_c,k+1,length(pp));

for ij = 1:length(pp) 
        
        [varcoeff,Omega_VAR,cnst_VAR] = Yule_Walker(Ck_f_full,alf,pp(ij),YWcheck,tol_err);
        
        %compute autocovariances of the implied VAR(p)
        hasconstant = 0; %=0,varcoeff does not include constant; =1, first column of varcoeff is the constant 
        [Ck_var,Nvar_c,nameXX] = autocov_var(varcoeff,Omega_VAR,pp(ij),hasconstant,k,N,lambda_hp,index_trans,tauvar);
        
        CCk_var_pp(:,:,:,ij) = Ck_var;
end


%unload the results
for jk = 1:length(pp)
    CCk_var = zeros(1,k+1,Nvar_c,Nvar_c);

    for ii = 1:Nvar_c
        for jj = 1:Nvar_c
            for kk = 1:k+1
                KK_(kk) = CCk_var_pp(ii,jj,kk,jk);
            end
            CCk_var(:,:,ii,jj) = KK_;
        end
    end
    
    if display_cov == 0
         CCk_var = cov_to_corr(CCk_var);
    end

    CCk_var_cell{jk} = CCk_var;
end

%--display autocovariances implied by the model (CCk_m) and by VAR_implied for different p
%first, construct string with names
nameXX = index_{1,4};
for jj = 2:size(index_,1)
    nameXX = strvcat(nameXX,index_{jj,4});
end

if display_cov == 1
    name_fig = 'Autocovariances: Model vs VAR(p)-implied';
elseif display_cov == 0
    name_fig = 'Autocorrelations: Model vs VAR(p)-implied';
end
leg_str = 'Model';
for ik = 1:length(pp)
   leg_str = strvcat(leg_str,['VAR(',num2str(pp(ik)),')']); 
end

CCk_m_cell{1} = CCk_m;
 
Nvar_plot = min(8,Nvar_c);

jjj =1;
kjj =1;
for jj = 1:Nvar_plot:Nvar_c
    nn0 = jj:min(Nvar_c,Nvar_plot*jjj);

    for kj =1:Nvar_plot:Nvar_c
        nn1 = kj:min(Nvar_c,Nvar_plot*kjj);

        plot_fig_autoc(name_fig,leg_str,k1,nameXX,nn0,nn1,CCk_m_cell,CCk_var_cell,t100)
        kjj = kjj+1;
    end
    kjj = 1;
    jjj = jjj+1;
end


%-------------------------------------------------------------------------
%----- Empirical autocovariances
%-------------------------------------------------------------------------

if index_do_trans==0 && index_do_hp ==0

    %-- (1) use sample-counterpart of E[(y(t)-mu)(y(t-k)-mu)']

    Xdat_s = Xdat(:,init_kalman+1:end);
    if init_kalman_switch == 1
        if init_kalman > k
            Xdat_s = Xdat(:,init_kalman-k+1:end);
        else
            Xdat_s = Xdat(:,:);
        end
    end

    keyboard
    if demean == 0
        Xdat_s = Xdat_s - repmat(mean(Xdat_s,2),1,size(Xdat_s,2)); %remove mean
    end

    Xdat_s_y = Xdat_s(:,1+k:end)';
    Tsamp = size(Xdat_s_y,1);

    if k > Tsamp-1
        error('fatal trying to estimate the sample counterpart of E[(y(t)-mu)(y(t-k)-mu)''] but k > Samplesize')
    end

    Xdat_s_x = [];
    if k > 0
        for ii = 1:k
            Xdat_s_x = [Xdat_s_x  Xdat_s(:,[1+k-ii:end-ii])'];
        end
    end
    gamyx = (Xdat_s_y'*Xdat_s_x)/Tsamp;
    gamyy = (Xdat_s_y'*Xdat_s_y)/Tsamp;

    Ck_e_s = zeros(Nvar_c,Nvar_c,k+1);
    Ck_e_s(:,:,1) = JJ*gamyy*JJ';
    for kk = 2:k+1
        Ck_e_s(:,:,kk) = JJ*gamyx(:,(kk-2)*Nvar+1:(kk-1)*Nvar)*JJ';
    end

    %unload the results
    CCk_e_s = zeros(1,k+1,Nvar_c,Nvar_c);
    for ii = 1:Nvar_c
        for jj = 1:Nvar_c
            for kk = 1:k+1
                KK_(kk) = Ck_e_s(ii,jj,kk); 
            end
            CCk_e_s(:,:,ii,jj) = KK_;
        end
    end

    if display_cov == 0
        CCk_e_s = cov_to_corr(CCk_e_s);
    end

else
    CCk_e_s = [];
end

% -- (2) fit a VAR

Xdat_v = Xdat(:,init_kalman+1:end);

if init_kalman_switch == 1
    if init_kalman > p
        Xdat_v = Xdat(:,init_kalman-p+1:end);
    else
        Xdat_v = Xdat(:,:);
    end
end

keyboard
if demean == 1 
    hasconstant = 0; 
elseif demean == 0
    hasconstant = 1;
end

[varcoeff_e,Omega_VAR_e] = estimatevar(Xdat_v',p,hasconstant,[]);

%-- compute autocovariances
[Ck_e_var,Nvar_c,nameXX] = autocov_var(varcoeff_e,Omega_VAR_e,p,hasconstant,k,N,lambda_hp,index_trans,tauvar);

%unload results
CCk_e_var = zeros(1,k+1,Nvar_c,Nvar_c);
for ii = 1:Nvar_c
    for jj = 1:Nvar_c
        for kk = 1:k+1
            KK_(kk) = Ck_e_var(ii,jj,kk);
        end
        CCk_e_var(:,:,ii,jj) = KK_;
    end
end

if display_cov == 0
    CCk_e_var = cov_to_corr(CCk_e_var);
end


%-- plot model-implied, VAR(p)-implied, and empirical autocovariances computed using sample-counterpart and VAR(p)
p_n = find(pp==p);
CCk_var_cell_m{1} = CCk_m;
CCk_var_cell_m{2} = CCk_var_cell{p_n};

CCk_e_var_cell{1} = CCk_e_s;
CCk_e_var_cell{2} = CCk_e_var;

if display_cov == 1
     name_fig = ['Autocovariances: Model (model-implied and VAR(',num2str(p),')-implied), and Empirical (sample-counterpart and/or VAR(',num2str(p),'))'];
elseif display_cov ==0
     name_fig = ['Autocorrelations: Model (model-implied and VAR(',num2str(p),')-implied), and Empirical (sample-counterpart and/or VAR(',num2str(p),'))'];
end

leg_str = strvcat('Model','Model-implied VAR');
if isempty(CCk_e_var_cell{1}) ==1
    leg_str = strvcat(leg_str,'Empirical, VAR');
else
    leg_str = strvcat(leg_str,'Empirical, Sample-counterpart','Empirical, VAR');
end

jjj =1;
kjj =1;
for jj = 1:Nvar_plot:Nvar_c
    nn0 = jj:min(Nvar_c,Nvar_plot*jjj);

    for kj =1:Nvar_plot:Nvar_c
        nn1 = kj:min(Nvar_c,Nvar_plot*kjj);

        plot_fig_autoc(name_fig,leg_str,k1,nameXX,nn0,nn1,CCk_var_cell_m,CCk_e_var_cell,t100)
        kjj = kjj+1;
    end
    kjj = 1;
    jjj = jjj+1;
end


%-------------------------------------------------------------------------
%--- Generate artificial samples and estimate autocovariances
%-------------------------------------------------------------------------
Ndraws = 10000; %10000 or 50000
Linit = 100; %initial observation that will be dropped
%
LL = size(Xdat,2) + Linit; %we add Linit because the first Linit observations will be dropped

xsmooth0 = zeros(size(F,1),1);

randn('state',123456); %Set seed so that results can be exactly replicated in a given Matlab version

chol_V  = (chol(V_eps))'; %lower triangular
chol_R = (sqrt(RR));

BD = [B1*D; zeros(size(B1,1),size(D,2)); D];
if is ==1
    BD = [BD; zeros(size(D))];
end


wait_bar   = waitbar(0,'Simulating artificial data, estimating VAR and computing autocovariances...');
set(wait_bar,'Name','Simulating data and computing autocovariances');

jij = 1;
count_var_expl = 0;
CCk_mc_var_ndraws = zeros(Ndraws,1,k+1,Nvar_c,Nvar_c);

while jij <= Ndraws
    innovation = randn(size(V_eps,1),1,LL);
    innovation = reshape(innovation,size(V_eps,1),LL);
    innovation  = chol_V*innovation;

    meas_err = randn(size(RR,1),1,LL);
    meas_err = reshape(meas_err,size(RR,1),LL);
    meas_err = chol_R*meas_err;

    xsmooth = zeros(size(F,1),LL);
    Yhat = zeros(size(Xdat,1),LL);

    xsmooth(:,1) = F*xsmooth0 + BD*innovation(:,1);
    Yhat(:,1) = H*xsmooth(:,1) + alf + meas_err(:,1);

    for ii = 2:LL
        xsmooth(:,ii) = F*xsmooth(:,ii-1) + BD*innovation(:,ii);
        Yhat(:,ii) = H*xsmooth(:,ii) + alf + meas_err(:,ii);
    end

    Yhat = Yhat(:,Linit+1:end); %drop initial observations

    Xdat_v = Yhat(:,init_kalman+1:end);

    if init_kalman_switch == 1
        if init_kalman > p
            Xdat_v = Yhat(:,init_kalman-p+1:end);
        else
            Xdat_v = Yhat(:,:);
        end
    end

    if demean == 1
        hasconstant = 0;
    elseif demean == 0
        hasconstant = 1;
    end

    [varcoeff_mc,Omega_VAR_mc] = estimatevar(Xdat_v',p,hasconstant,[]);

    %-- compute autocovariances
    try
    [Ck_mc_var,Nvar_c,nameXX,max_eig_] = autocov_var(varcoeff_mc,Omega_VAR_mc,p,hasconstant,k,N,lambda_hp,index_trans,tauvar);

     %unload results
     CCk_mc_var = zeros(1,k+1,Nvar_c,Nvar_c);
        for ii = 1:Nvar_c
            for jj = 1:Nvar_c
                for kk = 1:k+1
                    KK_(kk) = Ck_mc_var(ii,jj,kk);
                end
                CCk_mc_var(:,:,ii,jj) = KK_;
            end
        end

    if display_cov == 0
            CCk_mc_var = cov_to_corr(CCk_mc_var);
    end

    CCk_mc_var_ndraws(jij,:,:,:,:) = CCk_mc_var; %store results

    jij = jij+1;

    catch
        jij = jij-1;
        count_var_expl = count_var_expl + 1;
    end

    waitbar((jij-1)/Ndraws,wait_bar,sprintf('%f % of simulations already done',(jij-1)/Ndraws));
    jij
end

disp(' ')
disp([' ',num2str(count_var_expl),' out of ', num2str(Ndraws), ' draws have generated explosive VARs. These have been removed and replaced with non-explosive draws'])


%--order results in each period in ascending order, divide it up in quintiles
quintiles = [round(0.05*Ndraws) ...
    round(0.10*Ndraws)...
    round(0.15*Ndraws)...
    round(0.20*Ndraws)...
    round(0.25*Ndraws)...
    round(0.30*Ndraws)...
    round(0.35*Ndraws)...
    round(0.40*Ndraws)...
    round(0.45*Ndraws)...
    round(0.50*Ndraws)...
    round(0.55*Ndraws)...
    round(0.60*Ndraws)...
    round(0.65*Ndraws)...
    round(0.70*Ndraws)...
    round(0.75*Ndraws)...
    round(0.80*Ndraws)...
    round(0.85*Ndraws)...
    round(0.90*Ndraws)...
    round(0.95*Ndraws)];

tmp = zeros(Ndraws,k+1);
CCk_mc_var_median = zeros(1,k+1,Nvar_c,Nvar_c);
CCk_mc_var_mean = zeros(1,k+1,Nvar_c,Nvar_c);
CCk_mc_var_5p = zeros(1,k+1,Nvar_c,Nvar_c);
CCk_mc_var_95p = zeros(1,k+1,Nvar_c,Nvar_c);

for ii = 1:Nvar_c
    for jj = 1:Nvar_c
        for jij = 1:Ndraws
          tmp(jij,:) = (squeeze(CCk_mc_var_ndraws(jij,:,:,ii,jj)))';
        end
        tmp = sort(tmp);
        tmpMedian = tmp(round(Ndraws*0.5),:);
        tmpMean = mean(tmp);
        tmpDen = tmp(quintiles,:); %19 is the length of quintiles
        
        CCk_mc_var_median(:,:,ii,jj) = tmpMedian;
        CCk_mc_var_mean(:,:,ii,jj) = tmpMean;
        CCk_mc_var_5p(:,:,ii,jj) = tmpDen(2,:); %leave out first quintile
        CCk_mc_var_95p(:,:,ii,jj) = tmpDen(end-1,:); %leave out last quintile. Overall we consider 90% interval
        tmp = zeros(Ndraws,k+1);
    end
end

if entr == 1
    sub_entr = 'cmr';
elseif entr == -3
    sub_entr = 'bgg';
elseif entr == 0
    sub_entr = 'b';
elseif entr == 2
    sub_entr = 'fish';
elseif entr == -2
    sub_entr = 'sw';
elseif entr == -4
    sub_entr = 'bggreal';
end
save([outfolder '\autocov_MC_',sub_entr,'.mat'],'CCk_mc_var_median','CCk_mc_var_mean','CCk_mc_var_5p','CCk_mc_var_95p')

%-------------------------------------------------------------------------
%--- Plots
%-------------------------------------------------------------------------

%-- plot model-implied, VAR(p)-model-implied, mean estimated on articifial samples. Check for bias
p_n = find(pp==p);
CCk_var_cell_mm{1} = CCk_m;
CCk_var_cell_mm{2} = CCk_var_cell{p_n};

CCk_mc_var_cell{1} = CCk_mc_var_mean;
CCk_mc_var_cell{2} = CCk_mc_var_median;

if display_cov == 1
     name_fig = ['Autocovariances: Model (model-implied and VAR(',num2str(p),')-implied), and sampled (VAR(',num2str(p),'))'];
elseif display_cov ==0
     name_fig = ['Autocorrelations: Model (model-implied and VAR(',num2str(p),')-implied), and sampled (VAR(',num2str(p),'))'];
end

leg_str = strvcat('Model','Model-implied VAR','Mean, MonteCarlo','Median, MonteCarlo');

jjj =1;
kjj =1;
for jj = 1:Nvar_plot:Nvar_c
    nn0 = jj:min(Nvar_c,Nvar_plot*jjj);

    for kj =1:Nvar_plot:Nvar_c
        nn1 = kj:min(Nvar_c,Nvar_plot*kjj);

        plot_fig_autoc(name_fig,leg_str,k1,nameXX,nn0,nn1,CCk_var_cell_mm,CCk_mc_var_cell,t100)
        kjj = kjj+1;
    end
    kjj = 1;
    jjj = jjj+1;
end


%-- plot median, 5% and 95% estimated on articifial samples, and empirical ones based on VAR(p)
CCk_var_cell_mmm{1} = CCk_mc_var_median;
CCk_var_cell_mmm{2} = CCk_e_var;

CCk_mc_var_CI_cell{1} = CCk_mc_var_5p;
CCk_mc_var_CI_cell{2} = CCk_mc_var_95p;

if display_cov == 1
     name_fig = ['Autocovariances: DSGE (Median), DSGE (5-95 percent), and Data (VAR(',num2str(p),'))'];
elseif display_cov ==0
     name_fig = ['Autocorrelations: DSGE (Median), DSGE (5-95 percent), and Data (VAR(',num2str(p),'))'];
end

leg_str = strvcat('DSGE Median','Data, Var','DSGE 5%','DSGE 95%');

jjj =1;
kjj =1;
for jj = 1:Nvar_plot:Nvar_c
    nn0 = jj:min(Nvar_c,Nvar_plot*jjj);

    for kj =1:Nvar_plot:Nvar_c
        nn1 = kj:min(Nvar_c,Nvar_plot*kjj);

        plot_fig_autoc(name_fig,leg_str,k1,nameXX,nn0,nn1,CCk_var_cell_mmm,CCk_mc_var_CI_cell,t100)
        kjj = kjj+1;
    end
    kjj = 1;
    jjj = jjj+1;
end


%----------------------------------------------------------
%-- plot category-by-category
%---------------------------------------------------------
%unload the results
for jij = 1:size(Ck_f_categ,4)
    CCk_f_categ = zeros(1,k+1,Nvar_c,Nvar_c);
    for ii = 1:Nvar_c
        for jj = 1:Nvar_c
            for kk = 1:k+1
                KK_(kk) = Ck_f_categ(ii,jj,kk,jij);
            end
            CCk_f_categ(:,:,ii,jj) = KK_;
        end
    end
    if display_cov == 0
        CCk_f_categ = cov_to_corr(CCk_f_categ);
    end

    CCk_f_categ_cell{jij} = CCk_f_categ;
end

CCk_mc_var_mean_cell{1} = CCk_m;
CCk_mc_var_mean_cell{2} = CCk_mc_var_mean;

if display_cov == 1
     name_fig = 'Autocovariances: DSGE (mean), DSGE (model-implied), DSGE(model-implied, selected shocks)';
elseif display_cov ==0
     name_fig = 'Autocorrelations: DSGE (mean), DSGE (model-implied), DSGE(model-implied, selected shocks)';
end

leg_str = strvcat('Model','DSGE(Mean, MonteCarlo)');
for jj = 1:size(categ,1)
    leg_str = strvcat(leg_str,categ{jj,1});
end
%leg_str = strvcat(leg_str,'Meas. Err.');

jjj =1;
kjj =1;
for jj = 1:Nvar_plot:Nvar_c
    nn0 = jj:min(Nvar_c,Nvar_plot*jjj);

    for kj =1:Nvar_plot:Nvar_c
        nn1 = kj:min(Nvar_c,Nvar_plot*kjj);

        plot_fig_autoc(name_fig,leg_str,k1,nameXX,nn0,nn1,CCk_mc_var_mean_cell,CCk_f_categ_cell,t100)
        kjj = kjj+1;
    end
    kjj = 1;
    jjj = jjj+1;
end


%----------------------------------------------------------
%-- plot shock-by-shock 
%---------------------------------------------------------
plot_shockbyshock = 0;

if plot_shockbyshock ==1
    %unload the results
    for jij = 1:size(V_eps,1)
        CCk_f_jj = zeros(1,k+1,Nvar_c,Nvar_c);
        for ii = 1:Nvar_c
            for jj = 1:Nvar_c
                for kk = 1:k+1
                    KK_(kk) = Ck_f_jj(ii,jj,kk,jij);
                end
                CCk_f_jj(:,:,ii,jj) = KK_;
            end
        end
        if display_cov == 0
            CCk_f_jj = cov_to_corr(CCk_f_jj);
        end

        CCk_f_jj_cell{jij} = CCk_f_jj;
    end

    CCk_mc_var_mean_cell{1} = CCk_mc_var_mean;
    CCk_mc_var_mean_cell{2} = CCk_m;

    if display_cov == 1
        name_fig = 'Autocovariances: DSGE (mean), DSGE (model-implied), DSGE(model-implied, each shock at the time)';
    elseif display_cov ==0
        name_fig = 'Autocorrelations: DSGE (mean), DSGE (model-implied), DSGE(model-implied, each shock at the time)';
    end

    [vbname,signal_on,III,IIII] = findnum(taushock,parstoch,l_psi,shockss);

    leg_str = strvcat('DSGE(Mean, MonteCarlo)','Model');
    leg_str = strvcat(leg_str,vbname,'Meas. Err.');

    jjj =1;
    kjj =1;
    for jj = 1:Nvar_plot:Nvar_c
        nn0 = jj:min(Nvar_c,Nvar_plot*jjj);

        for kj =1:Nvar_plot:Nvar_c
            nn1 = kj:min(Nvar_c,Nvar_plot*kjj);

            plot_fig_autoc(name_fig,leg_str,k1,nameXX,nn0,nn1,CCk_mc_var_mean_cell,CCk_f_jj_cell,t100)
            kjj = kjj+1;
        end
        kjj = 1;
        jjj = jjj+1;
    end
end