[n1,n2]=size(rho);
N=n1/3;

nv=3*2*N;
[n5,n6]=size(alpha_0);
zr0=zeros(n5,3*N);
beta_0=betas(:,[1:3*N]);
beta_1=betas(:,[3*N+1:nv]);

beta0=[beta_0 zr0];
beta1=[beta_1 zr0];

F=alpha_0*A*B+alpha_0*B*P+alpha_1*B+beta0*P+beta1;
bw=size(A,1);

if money == 3
    if max(max(abs(F))) > .11e-9
        error('fatal (checkB) B matrix incorrect')
    end
end
if money ~= 3
    %exogenous shocks not contemporaneously observed to partial information equations:
    taup=[3 4 5 8 9 14 17 19];
    
    if money == 1  %if unity, then include money in list of shocks observed in partial information equations
        taup=[3 4 5 8 9 14 17];%under this specification the partial information equations can see the monetary shock
        disp('warning (checkB) monetary shock is observed in partial information equations')
    elseif money == 2
        taup=[19];%under this specification, all shocks but monetary policy are contemporaneously observed
    end
    
    nn=3;%number of elements in capital psi associated with each shock
    %pic contains the indeces of the shocks in capital psi not available to partial information equations:
    pic=[(taup(1)-1)*nn+1:(taup(1)-1)*nn+nn];
    
    if money == 2
        pic=[55 56];
    end
    
    if length(taup) > 1
        for ii = 2:7
            pic=[pic [(taup(ii)-1)*nn+1:(taup(ii)-1)*nn+nn] ];
        end
    end
    
    if money == 0
        pic=[pic [(taup(8)-1)*nn+1:(taup(8)-1)*nn+nn-1] ];
    end
    
    DD=eye(3*N);
    
    Dp=DD(pic,:);
    
    %ppic contains the shocks whose contemporaneous values are available to all equations
    tt=1:3*N;
    ix=0;
    for ii = 1:length(tt)
        ik=0;
        %consider putting tt(ii) into ppic. do so only if tt(ii) does not appear anywhere in pic
        for jj = 1:length(pic)
            if pic(jj)==tt(ii);ik=1;end
        end
        if ik == 0
            ix=ix+1;
            ppic(ix)=tt(ii);
        end    
    end
    
    Dt=DD(ppic,:);
    
    %partial information equations:
    if entr == 1
        part=[1, 4, 5, 11,12 13 14];
    elseif entr ==0
        part=[1 4 5 14 16 17 18 19];
    elseif entr ==-1
        part=[1 4 5 12 13:16];
    end
    
    %the full information equations, full, are just the complement of part in 1:27.
    ty=1:bw;
    ix=0;
    for ii = 1:length(ty)
        ik=0;
        %consider putting ty(ii) into full, but do so only if ty(ii) does not appear anywhere in part
        for jj = 1:length(part)
            if part(jj)==ty(ii);ik=1;end
        end
        if ik == 0
            ix=ix+1;
            full(ix)=ty(ii);
        end    
    end
    Db=[Dp
        Dt];
    
    nw=3*N;
    nv=2*nw;
    F1=F(:,[1:nw]);
    F2=F(:,[nw+1:nv]);
    F1b=F1*Db';
    
    [ns,nl]=size(Dp);
    F11b=F1b(:,[1:ns]);
    F12b=F1b(:,[ns+1:3*N]);    
    Ft1=F12b*Dt;
    Ft2=(F2+F11b*Dp*rho);
    
    Ft=zeros(bw,nv);
    for ii = full
        Ft(ii,:)=F(ii,:);
    end
    for ii = part
        Ft(ii,:)=[Ft1(ii,:) Ft2(ii,:)];
    end
    
    aa=max(max(abs(Ft)));
    %verify that the F-tilde matrix is zero
    ix=0;
    if aa > .1e-9
        for ii = 1:23
            for jj = 1:nv
                if abs(Ft(ii,jj)) > 3.1e-5
                    ix=ix+1;
                    II(ix,1)=ii;
                    II(ix,2)=jj;
                end
            end
        end
    end
    
    %verify that B has zeros in the places it should have zeros in
    iy=0;
    for ii = part
        for jj = pic
            if abs(B(ii,jj)) > .1e-9
                iy=iy+1;
                IJ(iy,1)=ii;
                IJ(iy,2)=jj;
            end
        end
    end
    
    if iy > 0 | ix > 0       
        error('fatal (checkB) check on B failed')
    end
    
end