function [QQ]=deriv(func,psi,varargin)
tol =   eps^(1/3);
onesided = 0; %=1 one-sided; =0 two-sided
%
t1=clock;

yb=feval(func,psi,varargin{:});

[a,b]=size(yb);
iend=length(psi);
if b ~= 1
 disp(' fatal (deriv) function should be column-vector valued')
 yb
 disp(' press any key to continue ...')
 pause
 return
end

%
QQ   = zeros(a,iend);
der  = zeros(a,iend);
pert = zeros(iend,1);
psid = zeros(iend,1);
%
%sprintf(' Entering DERIV, must go through %g steps',iend)
for ii=1:iend
    %sprintf(' step %g\n',ii)
    psid=psi;
    if abs(psi(ii)) > .1e-15
        pert(ii) = eps^(1/3)*max(abs(psi(ii)),1e-2);
        %pert(ii)=tol*psi(ii);        
    else
        pert(ii)=tol;
        %psid(ii)=psid(ii) + pert(ii);    
    end
    psid(ii) = psi(ii) + pert(ii);
    %pert(ii) = psid(ii) - psi(ii); % This increases precision slightly
    y1=feval(func,psid,varargin{:});
    der(:,ii)=(y1-yb);
    if onesided ==0
        psid(ii) = psi(ii) - pert(ii);
        y2=feval(func,psid,varargin{:});
        der(:,ii) = (y1-y2);
        pert(ii)  = pert(ii)*2;  %we multiply by two in case it is two sided as we need it below
    end
    %der(:,ii)=(y-yb);   
end

for ii = 1:iend
    QQ(:,ii) = der(:,ii)/pert(ii);
end
t2=clock;
fprintf('%g seconds used to linearize function\n',etime(t2,t1))