function []=doplot(tt,pi,Pe,beta,muzstar,out_R,yhat,infhat,inv_R,ihat,q_R,qhat,c_R,chat,wage_R,what,l_R,lhat, ...
                      real_R,Rehatp,nhatp,premiumhat,String1,number,Re,doRBC,t,entr)
                  
%this plotting program graphs impulse responses for the RBC model, as well
%as whatever version of the CMR model is being analyzed (i.e., entr = 1, 0
%or -1). It needs to know whether entr = 1 or not, because this determines
%if financial variables are to be plotted.
                  
%pap is unity when entr = 1 and 0 otherwise
%if number = 2, plot monetary and RBC model responses
%if number = 1, plot just the RBC responses

if doRBC == 3
    load RBCdat out_Rbase inv_Rbase c_Rbase l_Rbase real_Rbase q_Rbase
end

pap=1;                  
if isempty(nhatp) == 1
    pap=0;
end

figure
orient landscape

x=3;
xx=3; 
if number == 1
    x=2;
end
subplot(x,xx,1)
vline=(max(yhat*100)-min(yhat*100))/100; if sign(min(yhat))==1; indx=0.5;else; indx=1.5;end;
if number==2;plot(tt,yhat(tt)*100,'b-',tt,out_R(tt)*100,'ko-',t,yhat(t)*100,'*');end
if number==1
    if doRBC == 2
        plot(tt,out_R(tt)*100,'ko-')
        xlabel('t')
    elseif doRBC == 3
        plot(tt,out_R(tt)*100,tt,out_Rbase(tt)*100,'ko-')
        legend('Perturbed RBC Model','Baseline RBC Model')
        xlabel('t')
    end
end
axis tight
ylabel('percent');

title('Output');

subplot(x,xx,2)
if number==2
    plot(tt,ihat(tt)*100,'b-',tt,inv_R(tt)*100,'ko-',t,ihat(t)*100,'*')
    if entr==-2;legend('Simple Monetary Model','Real Business Cycle Model');end
    if entr==1;legend('Full Monetary Model','Real Business Cycle Model');end
end
if number==1
    if doRBC == 2
        plot(tt,inv_R(tt)*100,'ko-')
    elseif doRBC == 3
        plot(tt,inv_R(tt)*100,tt,inv_Rbase(tt)*100,'ko-',t,inv_R(t)*100,'*')
    end
    xlabel('t')
end
axis tight
ylabel('percent');
title('Investment');

subplot(x,xx,3)
if number == 2;plot(tt,chat(tt)*100,'b-',tt,c_R(tt)*100,'ko-',t,chat(t)*100,'*');end
if number == 1
    if doRBC==2
        plot(tt,c_R(tt)*100,'ko-')
    elseif doRBC == 3
        plot(tt,c_R(tt)*100,tt,c_Rbase(tt)*100,'ko-')
    end
    xlabel('t')
end
axis tight
ylabel('percent');
title('Consumption');

subplot(x,xx,4)
if number == 2;plot(tt,lhat(tt)*100,'b-',tt,l_R(tt)*100,'ko-',t,lhat(t)*100,'*');end
if number == 1
    if doRBC==2
        plot(tt,l_R(tt)*100,'ko-')
    elseif doRBC==3
        plot(tt,l_R(tt)*100,tt,l_Rbase(tt)*100,'ko-')
    end
    xlabel('t')
end
axis tight
ylabel('percent');
title('Hours Worked');

if number == 2
    subplot(x,xx,7)
    plot(tt,infhat(tt)*pi*400,'b-',t,infhat(t)*pi*400,'*');
    axis tight
    %set (gca,'XTick',[0 20])
    title('Inflation (APR)');
end

if number == 2
    subplot(x,xx,5)
    sp=Re/(1+Re);
    plot(tt,(sp*Rehatp(tt)-infhat(tt(1)+1:tt(end)+1))*(muzstar/beta)*400*100,'b-',tt,real_R(tt)*(muzstar/beta-1)*400*100,'ko-',t,(sp*Rehatp(t)-infhat(t(1)+1:t(end)+1))*(muzstar/beta)*400*100,'*')
    %set (gca,'XTick',[0 20])
title('Ex post realized real R_{t+1}^{e}/\pi _{t+1} (annual)')
elseif number == 1
    subplot(x,xx,5)
    if doRBC==2
        plot(tt,real_R(tt)*(muzstar/beta-1)*400*100,'ko-')
    elseif doRBC==3
        plot(tt,real_R(tt)*(muzstar/beta-1)*400*100,tt,real_Rbase(tt)*(muzstar/beta-1)*400*100,'ko-')
    end
    title('Riskfree rate with payoff in t+1 (annual)')
    xlabel('t')
end   

axis tight
ylabel('basis points')

if number == 2
    subplot(x,xx,8)
    plot(tt,Rehatp(tt)*Re*400*100,'b-',t,Rehatp(t)*Re*400*100,'*')
    %set (gca,'XTick',[0 20])
  
axis tight
title('Nominal rate of interest (R_{t+1}^{e}, annual)')
ylabel('basis points')
end 

if number == 2
    subplot(x,xx,6)
    plot(tt,qhat(tt)*100,'b-',tt,q_R(tt)*100,'ko-',t,qhat(t)*100,'*');
elseif number == 1
    subplot(x,xx,6)
    if doRBC==2
        plot(tt,q_R(tt)*100,'ko-');
    elseif doRBC==3
        plot(tt,q_R(tt)*100,tt,q_Rbase(tt)*100,'ko-');
    end
    xlabel('t')
end    
axis tight
%set (gca,'XTick',[0 20])
ylabel('percent');
title('P_{k''}');

if number == 2
    text(-60,-.7,'Note: subscript on nominal rate of interest indicates date of payoff. R_{t+1}^{e} is graphed at date t. \pi _{t} indicates gross change in price level from t-1 to t.')
    if pap == 1
        subplot(x,xx,8)
        plot(tt,nhatp(tt)*100,'b-',t,nhatp(t)*100,'*')
        axis tight
        %set (gca,'XTick',[0 20])
        ylabel('percent');
        title('Net Worth');
        
        subplot(x,xx,9)
        plot(tt,Rehatp(tt)*Re*400*100,'b-',t,Rehatp(t)*Re*400*100,'*')
        axis tight
        %set (gca,'XTick',[0 20])
        ylabel('basis points')
        title('Nominal Interest Rate (R_{t+1}^{e}, annual)');
    end
end

if number == 2;String1=[String1 ' Benchmark(-) and RBC(o)'];end
if number == 1;String1=[' Real Business Cycle Model'];end
hout=suptitle(String1);

if doRBC == 2
    out_Rbase=out_R;
    inv_Rbase=inv_R;
    c_Rbase=c_R;
    l_Rbase=l_R;
    real_Rbase=real_R;
    q_Rbase=q_R;
    save RBCdat out_Rbase inv_Rbase c_Rbase l_Rbase real_Rbase q_Rbase
end