%Exercise B: swap economy 

clear all

load d:\banking\exerciseB\inputsB A taus taum taub %(based on EA steadystate, EA elasticities with exception of xip, xiw and the two iotas which are from US)
load d:\banking\exerciseB\inputs1B rho %(based on: (1) estimated ea stochastic parameters, EA elasticities and everyting; (2)matrix A constructed using EA steadystate and estimated US xip and xiw and ea policy rule; (3) without switching-off M transformation
load d:\banking\exerciseB\inputs2B B1 %(based on: matrix A constructed using EA steadystate and estimated US xip and xiw and ea policy rule; (3) without switching-off M transformation
load d:\banking\swaprules\inputs2 psi z % psi z ((based on parameterseuro, estimated ea elasticities, ea policy rule, ea shocks); without switching out M transformation
load d:\banking\swaprules\innovations_ea err %err is the one estimated for the euro area model without switching out M transformation

psi0=psi;
z0=z;
clear psi z

%err(1:2,:) = err(1:2,:).*(0.2375/0.0288); %the estimated lambdaf shock has to be transformed multiplying it by the inverse of the coefficient in front of lambdaf in the Phillips curve: i.e. the inverse of (1-beta*xip)*(1-xip)/(xip*(1+beta*iota2)). This gives the true lambdaf. Then it has to be multiplied by (1-beta*xip)*(1-xip)/(xip*(1+beta*iota2)) evaluated at the US estimate

date= [1983.25:0.25:2006.00]';

%set initial condition
a=56; %56=1997; 60=1998:1;  48=1995:1

psi(:,a-1) = psi0(:,a-1);
z(:,a-1) = z0(:,a-1);
%err([19:20],56:90)=0; %You activate this if you want to see what happens,
%had the ECB not deviated from its rule under US structure.

% %adjust the innovations
% err(3,:)=err(3,:)*xb/xb1 ; %xb
% err(7,:)=err(7,:)*chi/chi1 ; %chi
% err(11,:)=err(11,:)*g/g1 ; %g
% err(13,:)=err(13,:)*muz/muz1 ; %muz
% err(15,:)=err(15,:)*gamma/gamma1 ; %gamma
% err(19,:)=err(19,:)*tauc/tauc1 ; %tauc
% err(21,:)=err(21,:)*sigma/sigma1 ; %sigma

for ii = a:92
    psi(:,ii)=rho*psi(:,ii-1)+err(:,ii);
    z(:,ii)=A*z(:,ii-1)+B1*psi(:,ii);
    Xt(:,ii)=taum*z(:,ii)+taub*z(:,ii-1)+taus*psi(:,ii);
end

%mean of fitted US inflation from 1999:1 to 2003:4 (times 400) is 0.145
%mean of fitted US output growth from 1999:1 to 2003:4 (times 400) is -0.646

XXt = Xt  ;

plot_data_mean= 0; %if = 1, the plots of the observable variables contained in XXt make use of the mean of the actual data rather than of the estimated mean of XXt itself
idat=0; %set =1 when prepare_short below works with the actual data. In that case, we want to do some smoothing on consumption before computing the marginal utility of consumption. Otherwise mu will go negative
% if plot_data_mean==1  %remove estimated mean and add mean of the data
%         XXt = XXt - mean((XXt)')'*ones(1,T) + mean((XXX)')'*ones(1,T);
% end
trendm1=zeros(92,1); %set trend to zero to avoid adding up the trend n times in the analysis of shocks below, where n is the number of shocks
trendm3=zeros(92,1); 
T =92;
fdiff =1;
alpha =0.36; %ea value
b =0.56; %eu value
beta =0.999; %ea value
mm=[];
addpath d:\banking\euroarea_code

[laborwedge,laborwedgea,effwedge,net,dmoney3,dmoney1,dinvest,dout,infl,dwage,dcons,Spread1,money1,money3, ...
        output,invest,cons,wage,price,hours,capacity,btott,dbtott,Rm_series,Re_series,Pe_series,govc,dgovc,idef,didef, ...
        oilp,doilp,Spread2] ...
    = prepare_short(XXt,mm,trendm3,trendm1,T,fdiff,alpha,b,beta,idat);

XXXt = [net;infl;hours;dbtott;dout;dwage;dinvest;dmoney1;dmoney3;dcons;Pe_series;Spread1;Rm_series;Re_series;capacity;dgovc;didef;doilp;Spread2];

[mean(infl(a:end)); mean(dout(a:end)); mean(400*Re_series(a:end))]

[std(infl(a:end)); std(dout(a:end)); std(400*Re_series(a:end))]

%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%results
infl_counter = infl;
dout_counter = dout;
Re_counter =Re_series;
clear infl dout Re_series

%load benchmark
load d:\banking\swaprules\benchmark infl dout Re_series%infl and dout in benchmark ea estimates

Re_string=400*0.00932932932933*(ones(size(dout(1,:)))');

figure
subplot(2,1,1)
plot(date(a:end),dout(a:end),'k',date(a:end),dout_counter(a:end),'r.-')
title('GDP Growth, Benchmark Estimation (solid) and Counterfactual under US Parameters(dotted)')
axis tight
subplot(2,1,2)
plot(date(a:end),infl(a:end),'k',date(a:end),infl_counter(a:end),'r.-')
title('Inflation, Benchmark Estimation (solid) and Counterfactual under US Parameters (dotted)')
axis tight
figure
plot(date(a:end),400*Re_series(a:end)+Re_string(a:end)','k',date(a:end),400*Re_counter(a:end)+Re_string(a:end)','r.-')
title('Interest rate (Re), Benchmark Estimation (solid) and Counterfactual under US Shocks (dotted)')
axis tight

