function [ffvl,y,phi,g,c,vn,uzc,lamz,Ra,her,Rm,dm,mb,m,erz,ev,hkb] = findvl(vl,k,muzstar,upsil,alpha,lambdaf,bigtheta,gamma,n,we, ...
    mu,G,Rk,pi,l,etag,i,b,zeta,psiL,sigmaL,lambdaw,w,taul,x,theta,Re,R,tau,chorse,chii,tauD,beta,sigmaq,v,tauc,psil,psik,ksi,xb, ...
    rhobank,pref,rk)


%equation aa29
y      =   ((vl*((k/(muzstar*upsil))^alpha)*(l^(1-alpha)))/lambdaf - bigtheta*((1-gamma)/gamma)*(n-we) - mu*G*(1+Rk)*k/(muzstar*pi));

% fix cost of production
phi         =   vl*((k/(muzstar*upsil))^alpha)*(l^(1-alpha))*(1-1/lambdaf);

% equation for g aa30
g           =   etag*y;

%equation aa22
c           =   y-i-g;

%equation for vn aa26
vn        =   (1/gamma)*(n-we);

%equation aa24
uzc        =  (muzstar-b*beta)/((muzstar-b)*c);

if y<0 | c < 0 | uzc < 0
    error('(findvl) y<0 | c < 0 | uzc < 0')
end

%equation aa21
lamz=zeta*psiL*(l^sigmaL)*lambdaw/(w*(1-taul));


%start loop on m. The lower bound on m is zero and the upper bound is defined by the requirement that Ra>=0. 
mlow = 0.000001;
mhigh =theta - 0.000001;
m=mlow;

[ffm1,Ra,her,Rm,dm,mb] = findm(mlow,x,theta,Re,R,tau,chorse,chii,tauD,pi,muzstar,beta,c,sigmaq,lamz,v,uzc,tauc,pref);
[ffm2,Ra,her,Rm,dm,mb] = findm(mhigh,x,theta,Re,R,tau,chorse,chii,tauD,pi,muzstar,beta,c,sigmaq,lamz,v,uzc,tauc,pref);
if ffm1*ffm2 > 0
    error('fatal (findvl) failed to bracket solution for m')
end       

opt =optimset('TolFun',1e-15,'TolX',1e-15,'Maxit',1000);
[m,fval,exitflag,output] =   fzero(@findmm,[mlow,mhigh],opt,x,theta,Re,R,tau,chorse,chii,tauD,pi,muzstar,beta,c,sigmaq,lamz,v,uzc,tauc,pref);
if exitflag < 0 | abs(fval) > .5e-8 | abs(imag(m)) > .1e-10 | m<0
    error('fatal (findvl) failed to find m')
end

[ffm,Ra,her,Rm,dm,mb] = findm(m,x,theta,Re,R,tau,chorse,chii,tauD,pi,muzstar,beta,c,sigmaq,lamz,v,uzc,tauc,pref);
%here end of loop on m

%equation aa16
costs=psil*w*l+psik*rk*k/(upsil*muzstar);
erz=(1-tau)*(mb/(pi*muzstar))*(1-m)-tau*costs;
if erz < 0 & entr ~= -1
    error('(findvl) erz<0')
end

%solve equation aa12 for ev
if abs(rhobank) < .1e-9
    ev= (her / ((1-ksi)*xb))^(-1/ksi);
else
    ev = ( ( (her/(xb*(1-ksi)))^(rhobank/(1-rhobank)) - (1-ksi) )*(1/ksi) )^(-1/rhobank);
end

%equation aa10
if abs(rhobank) < .1e-9
    zit=ev^(1-ksi);
else
    zit=(ksi+(1-ksi)*(ev^rhobank))^((1-rhobank)/rhobank);
end
hkb=alpha*ksi*xb*zit*((upsil*muzstar*l/k)^(1-alpha));

%verify whether equation aa13 is satisfied
ffvl= ev - erz/ ( (1-vl)*((k/(upsil*muzstar))^alpha)*(l^(1-alpha)) );