function [VYhat,Yhat,Ydata,xsmooth,Vsmooth] = forkalman(F,Q,xsmooth,Vsmooth,H,HH,R,alf,tauvar,BD,innovation,t1,LL)

xsmooth_old = xsmooth;

xsmooth(:,t1+1) = F*xsmooth(:,t1) + BD*innovation(:,1);
V = Q;
Vsmooth(:,:,t1+1) = V+F*Vsmooth(:,:,t1)*F';
jj = 2;

for ii = t1+2:t1+LL
    V = Q+F*V*F';
    %Vsmooth(:,:,ii) = V+(F^(ii-t1))*Vsmooth(:,:,ii-1)*(F^(ii-t1))';
    Vsmooth(:,:,ii)  = V+(F^(ii-t1))*Vsmooth(:,:,t1)*(F^(ii-t1))';
    xsmooth(:,ii) = F*xsmooth(:,ii-1) + BD*innovation(:,jj);
    jj = jj+1;
end

for ii = 1:t1+LL
    VYhat(:,:,ii)=H*Vsmooth(:,:,ii)*H'+R;
    Yhat(:,ii)=H*xsmooth(:,ii) + alf(tauvar'); %it includes only the variables in tauvar
    Ydata(:,ii)=HH*xsmooth(:,ii) + alf; %it includes all the observable variables
end

plott=0;
if plott==1
date=(1981.0:0.25:2010.75);
Tstart = find(date==1999.0);
figure, orient landscape
subplot(1,4,1); plot(date(Tstart:end),0.978*exp(xsmooth_old(30+30+17,Tstart:end)),'b-',date(t1:end),0.978*exp(xsmooth(30+30+17,t1:end)),'r:'  ); axis tight; %gamma
subplot(1,4,2); plot(date(Tstart:end),0.4851*exp(xsmooth_old(30+30+11,Tstart:end)),'b-',date(t1:end),0.4851*exp(xsmooth(30+30+11,t1:end)),'r:'  ); axis tight; %chi
subplot(1,4,3); plot(date(Tstart:end),100*xsmooth_old(30+30+27,Tstart:end),'b-',date(t1:end),100*xsmooth(30+30+27,t1:end),'r:'  ); axis tight; %xp
subplot(1,4,4); plot(date(Tstart:end),0.35*exp(xsmooth_old(30+30+29,Tstart:end)),'b-',date(t1:end),0.35*exp(xsmooth(30+30+29,t1:end)),'r:'); axis tight; %sigma
end