%load([outfolder '\maxlike'], 'err')
%load([outfolder '\maxlike'], 'err_220207')
%load([outfolder '\maxlike'], 'err_090307'); err = err_090307;
%load([outfolder '\err_'], 'err_160407'); err=err_160407;
load([outfolder '\naturalrate'], 'err_090307_090507'); innovation = err_090307_090507;

%make size of innovation equal to no_shocks times observations (i.e. it does NOT have to be in two pieces for each shock)
innovation = err([1:2:size(err,1)],2:end); %note: I remove first observation as it is= F*xsmooth(0)+v(1) and I haven't  computed xsmooth(0) yet

ExtremeCorrBound = 0.1;

[namesck,nameXXX] = getnames(fdiff);
namesck = namesck(taushock',:);

figure; orient landscape
n1=4;
n2=4;

tt_= find(date==1999.0);
line_vert = 2006.75; %last observation before starting the forecast

for ii=1:length(taushock)
   subplot(n1,n2,ii)
   plot(date(tt_:end),innovation(ii,tt_-1:end),'k-','LineWidth',2) %note that we dropped the first observation in err (and so in innovation). So we write here tt_-1
   axis tight
   line(date(tt_:end),zeros(size(date(tt_:end))),'LineStyle','-','LineWidth', 1,'Color',[0,0,0])
   
   line('XData',[line_vert+0.12, line_vert+.12],'YData',[min(0,min(innovation(ii,tt_-1:end))), ...
    max(0,max(innovation(ii,tt_-1:end)))],'LineStyle','-', 'LineWidth', 3, 'Color',[0.8 0.8 0.8])
   title(namesck(ii,:))
   grid on
end
hout=suptitle('Innovations');

covmat = innovation(:,:)*innovation(:,:)';
CorrH = diag(1./sqrt(diag(covmat)))*covmat*diag(1./sqrt(diag(covmat)));
CorrH_diag = sqrt(diag(covmat));
CorrH = tril(CorrH,-1);
[RowIndex,ColIndex] = find(abs(CorrH)>ExtremeCorrBound);
ExtremeCorrParams = cell(length(RowIndex),3);
for i=1:length(RowIndex)
    ExtremeCorrParams{i,1}=namesck(RowIndex(i),1:15);
    ExtremeCorrParams{i,2}=namesck(ColIndex(i),1:15);
    ExtremeCorrParams{i,3}=CorrH(RowIndex(i),ColIndex(i));
end
Index=[ExtremeCorrParams{:,3}];
[IInde,Index] = sort(abs(Index),2,'descend');
disp('Highest Correlation')
ExtremeCorrParams(Index,:)

%save([outfolder '\maxlike'], 'covmat', '-append')

%--------------------------
ii= size(innovation,2)-20; %ii=3 when you want to start from the beginning of the sample
LL=11; 
for jj=1:size(innovation,1)
    y_innov = innovation(jj,ii:end)'; 
    %x_innov = [ones(size(y_innov,1),1) innovation(jj,ii-1:end-1)']; %with constant
    x_innov = [innovation(jj,ii-1:end-1)']; %without constant
    bet = (x_innov'*x_innov)\(x_innov'*y_innov);
    res_innov = y_innov - x_innov(:,:)*bet;
    y_innov_for = zeros(LL,1);
    y_innov_for(1) = x_innov(end,:)*bet;
    for jk=2:LL
        %y_innov_for(jk) = [1 y_innov_for(jk-1)]*bet; %with constant
        y_innov_for(jk) = [y_innov_for(jk-1)]*bet; %without constant
    end
    y_innov_forcast(jj,:) = y_innov_for';
end

%------------------------------
figure; orient landscape
n1=4;
n2=4;  
date_ = [date(tt_:end)' date(end)+0.25:0.25:date(end)+0.25*LL ];
for ii=1:length(taushock)
   innov_forc = [innovation(ii,tt_-1:end) y_innov_forcast(ii,:)];
   subplot(n1,n2,ii)
   plot(date_,innov_forc,'k-','LineWidth',2)
   axis tight
   line(date_,zeros(size(date_)),'LineStyle','-','LineWidth', 1,'Color',[0,0,0])
   line('XData',[date(end)+0.12, date(end)+.12],'YData',[min(0,min(innov_forc)), ...
    max(0,max(innov_forc))],'LineStyle','-', 'LineWidth', 3, 'Color',[0.8 0.8 0.8])
   title(namesck(ii,:))
   grid on
   
end
hout=suptitle('Innovations & Projected Innovations');

keyboard
%save([outfolder '\maxlike'], 'y_innov_forcast', '-append')
%save([outfolder '\err_'], 'y_innov_forcast', '-append')
%%%
%%%
% 'Monetary Policy'    'Banking Technol'    [-0.7230]
% 'Oil Price, \tau'    'Government Cons'    [ 0.6180]
% 'Government Cons'    'Firm Markup, \l'    [-0.5553]
% 'Consumption Pre'    'Banking Technol'    [-0.5325]
% 'Term Spread    '    'Consumption Pre'    [ 0.5007]
% 'Riskiness of En'    'Financial Wealt'    [ 0.4942]
% 'Consumption Pre'    'Technology, \ep'    [ 0.4343]
% 'Oil Price, \tau'    'Firm Markup, \l'    [-0.3859]
% 'Money Demand Sh'    'Investment Spec'    [ 0.3762]
% 'Banking Technol'    'Inflation Objec'    [-0.3668]
% 'Consumption Pre'    'Monetary Policy'    [ 0.3658]
% 'Persistent Tech'    'Government Cons'    [-0.3606]
% 'Term Spread    '    'Banking Technol'    [-0.3569]
% 'Monetary Policy'    'Technology, \ep'    [ 0.3551]
% 'Money Demand Sh'    'Inflation Objec'    [-0.3433]
% 'Technology, \ep'    'Government Cons'    [ 0.3277]
% 'Consumption Pre'    'Firm Markup, \l'    [-0.2578]
% 'Riskiness of En'    'Technology, \ep'    [ 0.2567]
% 'Consumption Pre'    'Riskiness of En'    [ 0.2351]
% 'Oil Price, \tau'    'Money Demand Sh'    [-0.2334]
% 'Oil Price, \tau'    'Banking Technol'    [-0.2265]
% 'Investment Spec'    'Banking Technol'    [ 0.2202]
% 'Persistent Tech'    'Banking Technol'    [-0.2201]
% 'Financial Wealt'    'Persistent Tech'    [-0.2179]
% 'Term Spread    '    'Firm Markup, \l'    [-0.2134]
% 'Term Spread    '    'Inflation Objec'    [ 0.2088]
% 'Consumption Pre'    'Investment Spec'    [-0.2071]