function [z1,yhat,infhat,ihat,nhatp,qhat,chat,what,lhat,Rehatp,m3hat,premiumhat] = issingsimulate(alphas,alpha_0,alpha_1,alpha_2, ...
    betas,rho,D,taumat,c_y,i_y,Time,accuracy,entr,Gp,omegabar,G,Rk,k,n,alpha)

[A] = findandcheckA(alphas,alpha_2,alpha_1,alpha_0,accuracy);

[B,P]   =   solveb(A,alphas,betas,rho,taumat);

if max(max(abs(imag(A)))) > 1e-12
    error('fatal (solvemodel) A complex')
end
if max(max(abs(imag(B)))) > 2e-12
    error('fatal (solvemodel) B complex')
end

A=real(A);
B=real(B);

%simulate the model
epsbar=zeros(2,1);
epsbar(1)=0.01; 
eps0=D*epsbar;

if entr ==0  %we have made a change of variable in makealphabeta in order to impose information restrictions. We have now to undue the change
    Q = eye(25);
    if size(Q,1)>25 | size(Q,1)<25
        error('the size of Q and A is different')
    end
    Q(18,18) = 1-alpha;
    Q(18,8) = 1;
    QI=inv(Q);  
end

shock(:,[1])=eps0;
z1(:,[1])=B*eps0;
if entr==0
    z1(:,[1])=QI*z1(:,1);
end
for t=2:3,
    shock(:,[t])=rho*shock(:,[t-1]);
    z1(:,[t])=A*z1(:,[t-1])+B*shock(:,[t]);
    if entr ==0
        z1(:,t)=QI*z1(:,t);
    end
end
t=4;
shock(1:4,[t])=rho(1:4,1:4)*shock(1:4,[t-1]);
shock(5,t)=-shock(1,t);
z1(:,[t])=A*z1(:,[t-1])+B*shock(:,[t]);
if entr ==0
    z1(:,t)=QI*z1(:,t);
end

for t=5:Time,
    shock(:,[t])=rho*shock(:,[t-1]);
    z1(:,[t])=A*z1(:,[t-1])+B*shock(:,[t]);
    if entr ==0
        z1(:,t)=QI*z1(:,t);
    end
end

%unload the variables in z(t)
infhat=z1(1,[1:Time]);
shat=z1(2,[1:Time]);
rkhat=z1(3,[1:Time]);
ihat=z1(4,[1:Time]);
uhat=z1(5,[1:Time]);
if entr == 1
    omhat=z1(6,[1:Time]);
    ij=6;
elseif entr ==0 | entr ==-1
    ij=5;
end
Rkhat=z1(ij+1,[1:Time]);
if entr == 1 
    nhatp=z1(ij+2,[1:Time]);
    nhat=[0 nhatp([1:Time-1])];%nhat, beginning of period t
    ij=8;
elseif entr ==0 | entr == -1
    nhatp=[];
    ij=6;
end
qhat=z1(ij+1,[1:Time]);
qm1hat=[0 qhat([1:Time-1])];%qhat, period t-1 (for external finance premium)
if entr ==1 | entr==0
    vlhat=z1(ij+2,[1:Time]);
    evhat=z1(ij+3,[1:Time]);
    if entr ==1
        ij=11;
    elseif entr==0
        ij=9;
    end
elseif entr ==-1
    ij=7;
end
mbhatp = z1(ij+1,[1:Time]); %mb(t+1)
mbhat = [0 mbhatp([1:Time-1])]; %this is mb(t)
if entr ==1 | entr==0
    Rhat=z1(ij+2,[1:Time]);
    if entr ==1
        ij=13;
    elseif entr==0
        ij=11;
    end
elseif entr==-1
    ij=8;
end
uzchat=z1(ij+1,[1:Time]);
lamzhat=z1(ij+2,[1:Time]);
if entr ==1 | entr==0
    mhat=z1(ij+3,[1:Time]);
    Rahat=z1(ij+4,[1:Time]);
    if entr==1
        ij=17;
    elseif entr ==0
        ij=15;
    end
elseif entr==-1
    ij=10;
end
chat=z1(ij+1,[1:Time]);
what=z1(ij+2,[1:Time]);
lhat=z1(ij+3,[1:Time]);
kbhatp=z1(ij+4,[1:Time]);%kbar(t+1)
kbhat=[0 kbhatp([1:Time-1])];%convert to kbar(t)
Rehatp=z1(ij+5,[1:Time]);%this is Re(t+1)
Rehat=[0 Rehatp([1:Time-1])]; %this is Re(t)
xhat=z1(ij+6,[1:Time]);
if entr == 1 | entr==0
    dmhatp=z1(ij+7,[1:Time]); %this is dm(t+1)
    dmhat=[0 dmhatp([1:Time-1])]; %convert to dm(t)
    Rmhatp=z1(ij+8,[1:Time]); %this is Rm(t+1)
    Rmhat=[0 Rmhatp([1:Time-1])]; %this is Rm(t)
    m3hat=z1(ij+9,[1:Time]);
elseif entr ==-1
    m3hat=[];
end

yhat = (c_y).*chat+(i_y).*ihat;%goods output, exluding goods used in monitoring
if entr ==1 
    premiumhat = (Gp*omegabar/G)*omhat + (Rk/(1+Rk))*Rkhat + qm1hat + kbhat - (1/(k-n))*( k*(qm1hat + kbhat) - n*nhat);    
elseif entr ==0 | entr==-1
    premiumhat=[];
end
