function [H,F,Q,varargout]  =   kalman_matrices(D,rho,V_eps,A,alphas,betas, ...
         taumat,tau,her,ksi,Rb,Re,c,y,i,mb,m,x,psil,w,l,psik,rk,k,muzstar,n,pi,g,ev, ...
        taushock,Pe,G,Gp,omegabar,Rk,Gs,sigma,Taylor,fdiff,J,ric,M,m1,upsil,currdep,Ra,dm, ...
        m3,demean,mm,parstoch,l_eps,duration1,beta,tauvar,RR,gamma,alpha,R,ttt2,entr,tauC,duration2,taud,params)

l_z=size(A,1);

l_psi   =   length(rho);

[B,B1,B2,P,rrho,betas] = findandcheckB(A,alphas,rho,taushock,taumat,betas);

[alf,taum,taub,taus,tausb] = linear1(tau,her,ksi,Rb,Re,c,y,i,mb,m,x,psil,w,l,psik,rk,k,muzstar,n,pi,g,ev, ...
    Pe,G,Gp,omegabar,Rk,Gs,sigma,Taylor,fdiff,M,m1,upsil,currdep,Ra,dm,m3,l_z,demean,mm,taushock,parstoch, ...
    A,B1,B2,duration1,rho,beta,tauvar,gamma,alpha,R,ttt2,entr,tauC,duration2,taud,params);

is=0;
if max(max(abs(tausb))) > .1e-9
    is=1;
end

if is == 1
    F                                           =   zeros(2*(l_z+l_psi));
else
    F                                           =   zeros(2*l_z+l_psi);
end
    
F(1:l_z,1:l_z)                              =   A;
F(l_z+1:2*l_z,1:l_z)                        =   eye(l_z);
F(1:l_z,2*l_z+1:2*l_z+l_psi)                =   B1*rho+B2;
F(2*l_z+1:2*l_z+l_psi,2*l_z+1:2*l_z+l_psi)  =   rho;

if is == 1
    F(2*l_z+l_psi+1:end,2*l_z+1:2*l_z+l_psi)    =   eye(l_psi);
end

J1=J(:,12)==0;
if max(J1) == 1 & min(J1) == 1
    taum(12,:)=zeros(size(taum(12,:)));
    taub(12,:)=zeros(size(taub(12,:)));
    taus(12,:)=zeros(size(taus(12,:)));
    tausb(12,:)=zeros(size(tausb(12,:)));
end

if is == 1
    H                                           =   J*[taum,taub,taus,tausb];
else
    H                                           =   J*[taum,taub,taus];
end
if max(max(isnan(H))) == 1
    disp('trapped a misbehaging H')
end

if is == 1
    Q                                           =   zeros(2*(l_z+l_psi));
else
    Q                                           =   zeros(2*l_z+l_psi);
end

alf =alf(tauvar');

Q(1:l_z,1:l_z)                              =   B1*D*V_eps*D'*B1';
Q(1:l_z,2*l_z+1:2*l_z+l_psi)                =   B1*D*V_eps*D';
Q(2*l_z+1:2*l_z+l_psi,1:l_z)                =   D*V_eps*D'*B1';
Q(2*l_z+1:2*l_z+l_psi,2*l_z+1:2*l_z+l_psi)  =   D*V_eps*D';


check=0;

if ric == 1
    [initV,L,G,RRR]  =   dare(F',zeros(size(F)),Q);
    varargout(1)    =   {initV};
    if check == 1
        ee=initV-F*initV*F'-Q;
        if max(max(abs(ee))) > .1e-8
            error('fatal (kalman_matrices) failed to solve Riccati Equation')
        end
    end
else 
    if is == 1
        initV1  =   .01*eye(2*(l_z+l_psi));
    else
        initV1  =   .01*eye(2*l_z+l_psi);
    end
    for ii = 1:100
        initVn = F*initV1*F'+ Q;
        initV1 = initVn;
        %ee=max(max(abs(initV1-F*initV1*F'-Q)));
        %if max(max(abs(ee))) > .1e-8
        %    warning('fatal (kalman_matrices) approximation error very high')
        %end
    end
    varargout(1)    =   {initV1};
end

varargout(2)={is};
varargout(3)={alf};
varargout(4)={taum};
varargout(5)={taub};
varargout(6)={taus};
varargout(7)={tausb};
varargout(8)={D};
varargout(9)={B1};
varargout(10)={B2};
