function maketablesfacts(hp_filter,outfolder,country,lambda_hp,curdrive,namedir)

addpath([curdrive '\' namedir '\corr'])

if country == 2
    load([outfolder '\data_us'])
    
    term_us     = term(tt);
    reserves_us = log(Rnon_borr_res_def(tt));
    log_RM1_us  = log(Rm1_def(tt));
    log_RM3_us  = log(Rm3_def(tt));
    Re_us       = R_e(tt);
    infl_us     = Ddef_gdp(tt);
    lh_us       = log(Hours(tt));
    cons_us     = log(Rcons(tt));
    invest_us   = log(Rinvest(tt));
    risk_us     = Risk_P(tt);
    stock_us    = log(Rstock_def(tt));
    credit_us   = log(Rloans_def(tt));
    y_us        = log(y_def(tt));
    date_us(:,:)  = date(:,:);
    
    AA = hpfilt(length(tt),lambda_hp);

    if hp_filter == 1
        US = [y_us cons_us invest_us lh_us infl_us stock_us credit_us risk_us/400 y_us-lh_us term_us/400 Re_us/400 log_RM1_us log_RM3_us reserves_us];
        US_cyc = AA*US;
    else
        tt=2:length(date_us);
        US_cyc=[diff(y_us) diff(cons_us) diff(invest_us) diff(lh_us) infl_us(tt) diff(stock_us) diff(credit_us) risk_us(tt)/400 diff(y_us-lh_us) term_us(tt)/400 Re_us(tt)/400 diff(log_RM1_us) diff(log_RM3_us) diff(reserves_us)];
        date_us=date_us(tt);
    end
    title_us=[  '&output             '
        '&consumption        '
        '&investment         '
        '&hours              '
        '&inflation          '
        '&stock market       '
        '&credit             '
        '&premium            '
        '&labor productivity '
        '&term structure     '
        '&interest rate      '
        '&real M1            '
        '&real M3            '
        '&nb reserves        '];

    lag  = 4;
    thet = 1;
    l    = 3;
    ix   = 1;
    cc_us= [];

    for ii = 2:size(US_cyc,2)
        w = US_cyc(:,ii);
        [V,rnw,snsw,B,S,T] = correlate(w,US_cyc(:,1),lag,thet,l);
        cc_us(ix,:) = B(1,[10 1 4 5 6 9]);
        cc_us(ix+1,:) = B(2,[10 1 4 5 6 9]);
        ix=ix+2;
    end
    sy = std(US_cyc(:,1));
    t1 = 1:size(US_cyc,1)-1;
    t2 = 2:size(US_cyc,1);
    dd = corrcoef(US_cyc(t1,1),US_cyc(t2,1));
    a  = [sy 0 dd(1,2) 1 dd(1,2) 0];
    cc_us = [a
        zeros(1,6)
        cc_us];

elseif country == 1
    load([outfolder '\data_ea'])
    
    log_RM1   = log(Rm1_def(tt));
    log_RM3   = log(Rm3_def(tt));
    Re_ea     = R_e(tt);
    infl_ea   = Ddef_gdp(tt);
    lh_ea     = log_Hours(tt);
    cons_ea   = log(Rcons(tt));
    invest_ea = log(Rinvest(tt));
    risk_ea   = Risk_P(tt);
    stock_ea  = log(Rstock_def(tt));
    credit_ea = log(Rloans_def(tt));
    y_ea      = log(y_def(tt));
    term_ea   = term(tt);
    date_ea(:,:)   = date(:,:);
    
    AA = hpfilt(length(tt),lambda_hp);

    if hp_filter == 1
        EA=[y_ea cons_ea invest_ea lh_ea infl_ea stock_ea credit_ea risk_ea/400 y_ea-lh_ea term_ea/400 Re_ea/400 log_RM1 log_RM3];
        EA_cyc=AA*EA;
    else
        tt=2:length(date_ea);
        date_ea=date_ea(tt);
        EA_cyc=[diff(y_ea) diff(cons_ea) diff(invest_ea) diff(lh_ea) infl_ea(tt) diff(stock_ea) diff(credit_ea) risk_ea(tt)/400 diff(y_ea-lh_ea) term_ea(tt)/400 Re_ea(tt)/400 diff(log_RM1) diff(log_RM3)];
    end
    title_ea=[  '&output             '
        '&consumption        '
        '&investment         '
        '&hours              '
        '&inflation          '
        '&stock market       '
        '&credit             '
        '&spread             '
        '&labor productivity '
        '&term structure     '
        '&interest rate      '
        '&real M1            '
        '&real M3            '];
    
    lag  = 4;
    thet = 1;
    l    = 3;
    ix   = 1;
    cc_ea=[];

    ix=1;
    for ii = 2:size(EA_cyc,2)
        w = EA_cyc(:,ii);
        [V,rnw,snsw,B,S,T] = correlate(w,EA_cyc(:,1),lag,thet,l);
        cc_ea(ix,:) = B(1,[10 1 4 5 6 9]);
        cc_ea(ix+1,:) = B(2,[10 1 4 5 6 9]);
        ix = ix+2;
    end
    sy = std(EA_cyc(:,1));
    t1 = 1:size(EA_cyc,1)-1;
    t2 = 2:size(EA_cyc,1);
    dd = corrcoef(EA_cyc(t1,1),EA_cyc(t2,1));
    a = [sy 0 dd(1,2) 1 dd(1,2) 0];
    cc_ea = [a
        zeros(1,6)
        cc_ea];
end

%load the model second moments generated by get2moments.m
if country==1
    load([outfolder '\second_Mod_ea'])
elseif country == 2
    load([outfolder '\second_Mod_us'])
end

label=['$\\sigma _ {\\lambda _ f}$                                     '
    '$\\sigma _{x^{b}}$                                             '
    '$\\sigma _{\\mu _{\\Upsilon }}$                                '
    '$\\sigma _{\\chi }$                                            '
    '$\\sigma _{g}$                                                 '
    '$\\sigma _{\\mu _{z}^{\\ast }}$                                '
    '$\\sigma _{\\gamma }$                                          '
    '$\\sigma _{\\gamma^{\\text{signal}}}$                          '
    '$\\sigma _{\\epsilon }$                                        '
    '$\\sigma _{\\varepsilon ^{\\text{policy}}}$                    '
    '$\\sigma _{\\sigma }$                                          '
    '$\\sigma _{\\sigma^{\\text{signal}}}$                          '
    '$\\sigma _{\\xi _{c}}$                                         '
    '$\\sigma _{\\xi _{i}}$                                         '
    '$\\sigma _{\\tau^{\\text{oil}}}$                               '
    '$\\sigma _{\\aleph }$                                          '
    'all economic shocks                                            '
    '$\\sigma _{\\sigma }$ and $\\sigma _{\\sigma^{\\text{signal}}}$'
    'all shocks (also ME)                                           '
    'measurement error                                              '
    'inflation target                                               '];
if country == 2
    label = [label(1,:)
        '$\\xi $                                                        '
        label(2:end,:)];
end
MM = [];
VAR = [];
relVAR = [];
%MM contains the correlations (third column of Modi)
%VAR contains the variances (fifth column of Modi)
%relVAR contains relative standard deviations (first column of Modi)
for ii = 1:KU
    if hp_filter == 1
        tt = ['MM=[MM Mod',num2str(ii),'(:,3)];'];
        tp = ['VAR=[VAR Mod',num2str(ii),'(:,5)];'];
        tz = ['relVAR=[relVAR Mod',num2str(ii),'(:,1)];'];
    else
        tt = ['MM=[MM ModD',num2str(ii),'(:,3)];'];
        tp = ['VAR=[VAR ModD',num2str(ii),'(:,5)];'];
        tz = ['relVAR=[relVAR ModD',num2str(ii),'(:,1)];'];
    end
    eval(tt);
    eval(tp);
    eval(tz);
end

VARdecomp = zeros(size(VAR));

for ii = 1:size(VARdecomp,2);
    VARdecomp(:,ii) = 100*VAR(:,ii)./VAR(:,19+ia);
end

%with itest = 1, tables are printed to test.tex.
itest = 0;
if itest~=1
    if country == 1
        if hp_filter == 1
            name = 'staticmoments_ea_hp.tex';
        else
            name = 'staticmoments_ea_diff.tex';
        end
    else
        if hp_filter == 1
            name = 'staticmoments_us_hp.tex';
        else
            name = 'staticmoments_us_diff.tex';
        end
    end
    maketableheader
else
    name = [];
    fid = [];
end

%variables, in the order they appear on in title:
%shock & output (1)& consumption (2)& investment (3)& hours (4)& inflation (5)& stock market (6)
%& credit(7) & spread (8)& labor productivity (9)& term structure(10) & interest rate (11) &real M1 (12)& real M3(13)
%in the case of the US, the last variable is nonborrowed reserves (14)
    
ttable1 = [ 1 2 3 4 5 9 11];%variables in the first table
ttable2 = [ 6 7 8 10 12 13];%variables in the second table
if country==2; ttable2 = [ttable2 14]; end
%get the indeces of the variables and their standard errors

%this produces a table with relative variances
if country==1
    if hp_filter == 1
        tabletitle='Table: Standard Deviation of $x$ Relative to Standard Deviation of Output, HP filtered data, EA';
    else
        tabletitle='Table: Standard Deviation of $x$ Relative to Standard Deviation of Output, differenced data, EA';
     end        
else
    if hp_filter == 1
        tabletitle='Table: Standard Deviation of $x$ Relative to Standard Deviation of Output, HP filtered data, US';
    else
        tabletitle='Table: Standard Deviation of $x$ Relative to Standard Deviation of Output, differenced data, US';
    end
end

ff = [19+ia [1:12+ia] 18+ia [13+ia:16+ia] 21+ia];
if country ==2
    maketablerelvariance(cc_us,relVAR,country,name,label,ff,fid,itest,hp_filter,title_us,ttable1,ttable2,tabletitle,outfolder);
else
    maketablerelvariance(cc_ea,relVAR,country,name,label,ff,fid,itest,hp_filter,title_ea,ttable1,ttable2,tabletitle,outfolder);
end

%this produces a table with variance decomposition
if country==1
    if hp_filter == 1
        tabletitle='Table: Variance Decomposition, HP filtered data, EA';
    else
        tabletitle='Table: Variance Decomposition, differenced data, EA';
     end        
else
    if hp_filter == 1
        tabletitle='Table: Variance Decomposition, HP filtered data, US';
    else
        tabletitle='Table: Variance Decomposition, differenced data, US';
    end
end

ss = [[1:12+ia] 18+ia [13+ia:16+ia] 20+ia 21+ia 19+ia];
if country ==2
    maketablevardecomp(VARdecomp,country,name,label,ss,fid,itest,hp_filter,ttable1,ttable2,title_us,tabletitle,outfolder);
else
    maketablevardecomp(VARdecomp,country,name,label,ss,fid,itest,hp_filter,ttable1,ttable2,title_ea,tabletitle,outfolder);
end

%this produces a table with all the contemporaneous correlations
if country==1
    if hp_filter == 1
        tabletitle='Table: Contemporaneous Correlation, $x_{t}$ with output, EA, HP filtered data';
    else
        tabletitle='Table: Contemporaneous Correlation, $x_{t}$ with output, EA, HP filtered data';
    end
else
    if hp_filter == 1
        tabletitle='Table: Contemporaneous Correlation, $x_{t}$ with output, US, HP filtered data';
    else
        tabletitle='Table: Contemporaneous Correlation, $x_{t}$ with output, US, differenced data';
    end
end

ff = [19+ia [1:12+ia] 18+ia [13+ia:16+ia] 21+ia];
if country == 2
    maketablecorrwithy(cc_us,MM,name,label,ff,fid,itest,hp_filter,ttable1,ttable2,title_us,tabletitle,outfolder);
else
    maketablecorrwithy(cc_ea,MM,name,label,ff,fid,itest,hp_filter,ttable1,ttable2,title_ea,tabletitle,outfolder);
end


%this produces a table with correlations and relative variances predicted by different shocks
%for this to work properly you have to have 19 (all shocks) first ...
gg = [19+ia [1:18+ia] 21+ia];
%gg=19;

for ii = gg
    lab=['''',deblank(label(ii,:)),''''];
    if country == 1
        if hp_filter == 1
            tt=['maketable2moments(country,cc_ea,real(Mod',num2str(ii),'),',lab,',fid,hp_filter);'];
        else
            tt=['maketable2moments(country,cc_ea,real(ModD',num2str(ii),'),',lab,',fid,hp_filter);'];
        end
    else
        if hp_filter == 1
            tt=['maketable2moments(country,cc_us,real(Mod',num2str(ii),'),',lab,',fid,hp_filter);'];
        else
            tt=['maketable2moments(country,cc_us,real(ModD',num2str(ii),'),',lab,',fid,hp_filter);'];
        end
    end
    eval(tt);
    if ii == 19+ia
        if length(gg) > 1
            fprintf(fid,'\\end{document}\n');
            fclose(fid);
            if hp_filter == 1
                if country == 1
                    name='dynamicmoments_ea_hp.tex';
                else
                    name='dynamicmoments_us_hp.tex';
                end
            else
                if country == 1
                    name='dynamicmoments_ea_diff.tex';
                else
                    name='dynamicmoments_us_diff.tex';
                end
            end
            maketableheader
        end            
    end
end
fprintf(fid,'\\end{document}\n');
fclose(fid);

return
subplot(221)
plot(date_us,US_cyc(:,1)/std(US_cyc(:,1)),date_us,US_cyc(:,3)/std(US_cyc(:,3)),'*-',date_us,US_cyc(:,6)/std(US_cyc(:,6)),'o-',date_us,US_cyc(:,7)/std(US_cyc(:,7)),'+-')
%plot(date_us,US_cyc(:,1),date_us,AA*(invest_us-y_us),'*-',date_us,AA*(stock_us-y_us),'o-',date_us,AA*(credit_us-y_us),'+-')
legend('real GDP','real investment','stock','credit')
title('US data')
axis tight

subplot(222)
plot(date_ea,EA_cyc(:,1)/std(EA_cyc(:,1)),date_ea,EA_cyc(:,3)/std(EA_cyc(:,3)),'*-',date_us,EA_cyc(:,6)/std(EA_cyc(:,6)),'o-',date_ea,EA_cyc(:,7)/std(EA_cyc(:,7)),'+-')
%plot(date_us,US_cyc(:,1),date_us,AA*(invest_us-y_us),'*-',date_us,AA*(stock_us-y_us),'o-',date_us,AA*(credit_us-y_us),'+-')
legend('real GDP','real investment','stock','credit')
axis tight
title('EA data')


y_us_trend=y_us-AA*y_us;
plot(date_us,y_us_trend,date_us,y_us)
axis tight