function [Ra,mb,lamz,her,ix,costs,psiL,erz,ev,ksi,xb,hkb,Rm,dm,ff] = oldmblamz(m,x,theta,pii,muzstar, ...
   beta,tauD,tau,R,Re,v,c,sigmaq,uzc,tauc,sigmaL,zeta,lambdaw,taul,psil,w,l,psik,rentk,k,vk,alpha,pref,entr,rhobank,chorse,upsil,chii,ix)

Ra = fRa(m,x,theta,Re);
if Ra < 0;ix(8)=1; error('(oldmblamz) Ra<0');end

%equation aa15
her=(1+R/Ra)/((1-tau)*(R/Ra)-tau);
if her < 0 & entr ~= -1
    ix(9)=1;
    error('(oldmblamz) her<0')
end

% equation for Rm aa8
Rm = Re - chorse*R/(her*tau+1);
if Rm < 0
    ix(10)=1;
    error('(oldmblamz) Rm<0')
end


if pref == 0%ACEL preferences
    
    %equation aa20:
    lamz=uzc/(1+tauc);
    
    %FOC for Dm over FOC M
    bb = ((1-chii)*theta/m)-((1-chii)*(1-theta)/(1-m));
    dm = chii*(1-tauD)*Ra / ( bb*pii*( (muzstar/beta)- ((1+(1-tauD)*Rm)/pii)) );
 
    %solve aa20 for mb:
    aab=v*(( ((1/m)^((1-chii)*theta)) * ((1/(1-m))^((1-chii)*(1-theta))) * (1/dm)^chii)^(1-sigmaq))*bb;
    mb=muzstar*pii*(lamz*(1-tauD)*Ra/aab)^(1/(sigmaq-2));
    if mb < 0 | imag(mb) > .1e-10 | dm<0
        error('fatal (oldmblamz) mb or dm is negative')
    end
    
elseif pref == 1 %benchmark preferences
    %equation for dm 
    bb = ((1-chii)*theta/m)-((1-chii)*(1-theta)/(1-m));
    dm = chii*(1-tauD)*Ra / ( bb*pii*( (muzstar/beta)- ((1+(1-tauD)*Rm)/pii)) );

    itest=0;
    if itest == 1
        mbb=[.001:.1:100];
        for ii = 1:length(mbb)
            mb=mbb(ii);
            [left,right,lamz,dm] = findmb(mb,v,m,c,theta,x,sigmaq,tauD,Ra,uzc,tauc,muzstar,pii,beta,Rm,chii,dm);
            ll(ii)=left;
            rr(ii)=right;
        end
        plot(mbb,ll,mbb,rr)
    end 
    mb1=0.000001; %.001;
    mb2=1e8; %1e4;
    
    %try to bracket the solution
    %[left1,right1,lamz1,dm] = findmb(mb1,v,m,c,theta,x,sigmaq,tauD,Ra,uzc,tauc,muzstar,pi,beta,Rm,chii,dm);
    %[left2,right2,lamz2,dm] = findmb(mb2,v,m,c,theta,x,sigmaq,tauD,Ra,uzc,tauc,muzstar,pi,beta,Rm,chii,dm);
    %if (left1-right1)*(left2-right2) > 0
    %    error('fatal (oldmblamz) failed to bracket solution for mb')
    %end
    
    opt =optimset('TolFun',1e-12,'TolX',1e-12,'Maxit',1000);
    [mb,fval,exitflag,output] =   fzero(@findmbb,[mb1,mb2],opt,v,m,c,theta,x,sigmaq,tauD,Ra,uzc,tauc,muzstar,pii,beta,Rm,chii,dm);
    if exitflag < 0 | abs(fval) > .7e-7 | abs(imag(mb)) > .1e-10 | mb < 0 
        ix(10)=1;
       error('fatal (oldmblamz) failed to find lamz and mb')
    end
    [left,right,lamz,dm] = findmb(mb,v,m,c,theta,x,sigmaq,tauD,Ra,uzc,tauc,muzstar,pii,beta,Rm,chii,dm);
    if lamz < 0 | mb < 0 | dm < 0
        ix(11)=1;
        error('(oldmblamz) lamz < 0 | mb < 0 | dm < 0')
    end
end

%equation aa21
psiL=(w*lamz*(1-taul)/lambdaw)/(zeta*(l^sigmaL));

%equation aa16
costs=psil*w*l+psik*rentk*k/(upsil*muzstar);
erz=(1-tau)*(mb/(pii*muzstar))*(1-m)-tau*costs;
if erz < 0 & entr ~= -1
    ix(12)=1;
    error('(oldmblamz) erz<0')
end

%equation aa13
ev=erz/ ( (1-vk)*((k/(upsil*muzstar))^alpha)*(l^(1-alpha)) );

%equation aa14
bba=(mb/(pii*muzstar))*(1-m+chorse*dm)+costs;
mm=bba/(her*erz);
ksi=(mm-1)/( (ev^(-rhobank)) -1 + mm );
if (ksi < 0 | ksi > 1) & entr ~= -1
    ix(13)=1;
    error('(oldmblamz) ksi<0')
end

%equation aa12
if abs(rhobank) < .1e-9
    xb=(ev^ksi)*her/(1-ksi);
else
    xb=her/( (1-ksi)*(ksi*(ev^(-rhobank))+(1-ksi))^((1-rhobank)/rhobank) );
end
if xb<0
    ix(14)=1;
    error('(oldmblamz) xb<0')
end

%equation aa10
if abs(rhobank) < .1e-9
    zit=ev^(1-ksi);
else
    zit=(ksi+(1-ksi)*(ev^rhobank))^((1-rhobank)/rhobank);
end
hkb=alpha*ksi*xb*zit*((upsil*muzstar*l/k)^(1-alpha));

%equation aa8
ff=(1+psik*R)*rentk-R*hkb/(1+tau*her);