%-------------------------------------------------------------------------------------------
%        Set parameter values of the exogenous stochastic processes and their respective priors
%        Set values and priors for measurement errors
%--------------------------------------------------------------------------------------------

rho1_lambdaf    =   0.972144344445234;   %AR(1) coefficient
rho2_lambdaf    =   0.0; %AR(2) coefficient
p_lambdaf       =   0;   %number of periods extending between the signal and the realisation of the shock 
std1_lambdaf    =   0.010464309676553;%standard deviation of shock. This is used in the computation of impulse responses
std2_lambdaf    =   0.0212; %0.01; %standard deviation of signal. This is used in the computation of impulse responses
%set priors
prior_rho1_lambdaf = [1,0.5,0.2]; %1th column is the shape; 2nd and 3rd are parameters used to compute density (opportunely transformed if needed)
                    %shape: 1 is BETA(mean,stdd); parameters a and b needed to evaluate Beta distribution are computed automatically on the basis of the 'mean' and 'stdd' specified by the user
                    %       2 is INVGAMMA(mode,d); d gives the degrees of freedom
                    %       3 is NORMAL(mean,stdd)
                    %       4 is uniform(a,b)
                    %       5 is Gamma(mean,stdd)
                    %       6 is Weibull(a, b) where a is a scale parameter that controls the mode and b the shape 
prior_rho2_lambdaf = [1,0.5,0.2]; %1th column is the shape; 2nd and 3rd are parameters used to compute density (opportunely transformed if needed)
prior_std1_lambdaf = [2,0.0005,5]; %prior_std_lamf1 = [2,0.01,5]; %Note: prior is on std!. Smets and Wouters set d=2 in all of the invgamma priors 
prior_std2_lambdaf = [2,0.00005,2];


rho1_pitarget      =   0.965;
rho2_pitarget      =   0;
p_pitarget         =   0;
std1_pitarget      =   0.0003; %0.0003; %0.00025; % %0.000149066345280;
std2_pitarget      =   0.000779;
%set priors on parameters
prior_rho1_pitarget = [1,0.99,0.01]; %1th column is the shape; 2nd and 3rd are parameters used to compute density
prior_rho2_pitarget = [1,0.1,0.1];
prior_std1_pitarget = [2,0.0001,5];  %prior_std1_pitarget = [2,0.000175,20]; 
prior_std2_pitarget = [2,0.0001,5];


rho1_psil      =  0.99;
rho2_psil      =  0.0;
p_psil         =  0;
std1_psil      =  0.01;
std2_psil      =  0.01;
%set priors on parameters
prior_rho1_psil = [1,0.75,0.1]; %1th column is the shape; 2nd and 3rd are parameters used to compute density 
prior_rho2_psil = [1,0.1,0.1]; 
prior_std1_psil = [2,0.00005,2]; 
prior_std2_psil = [2,0.00005,2];


rho1_psik     =   0.9;
rho2_psik     =   0;
p_psik        =   0;
std1_psik     =   0.1;
std2_psik     =   0.01;
%set priors on parameters
prior_rho1_psik = [1,0.8,0.1]; %1th column is the shape; 2nd and 3rd are parameters used to compute density 
prior_rho2_psik = [1,0.1,0.1]; 
prior_std1_psik = [2,0.2,2]; 
prior_std2_psik = [2,0.00005,2];


rho1_ksi       =   0.8;%0.9;
rho2_ksi       =   0;
p_ksi          =   0;
std1_ksi       =   0.01;
std2_ksi       =   0.01;
%set priors on parameters
prior_rho1_ksi = [1,0.5,0.2]; %1th column is the shape; 2nd and 3rd are parameters used to compute density 
prior_rho2_ksi = [1,0.1,0.1]; 
prior_std1_ksi = [2,0.001,5]; 
prior_std2_ksi = [2,0.00005,2];


rho1_xb       =  0.976744040561079; %0.98366;
rho2_xb       =  0;
p_xb          =  0;
std1_xb       =  0.090904687135412;
std2_xb       =  0.01;
%set priors on parameters
prior_rho1_xb = [1,0.5,0.2]; %1th column is the shape; 2nd and 3rd are parameters used to compute density 
prior_rho2_xb = [1,0.1,0.1]; 
prior_std1_xb = [2,0.1,5]; %prior_stddxb1 = [2,0.001,5];
prior_std2_xb = [2,0.00005,2];


rho1_muup      =   0.977227501421948 ;
rho2_muup      =   0;
p_muup         =   0;
std1_muup      =   0.003348205034942 ;
std2_muup      =   0.00292;
%set priors on parameters
prior_rho1_muup = [1,0.5,0.2]; %1th column is the shape; 2nd and 3rd are parameters used to compute density 
prior_rho2_muup = [1,0.1,0.1]; 
prior_std1_muup = [2,0.003,5]; %prior_stddmuup1 = [2,0.003,5];
prior_std2_muup = [2,0.00005,2];


rho1_theta    =   0.936;%0.9;
rho2_theta    =   0;
p_theta       =   0;
std1_theta    =   0.6;
std2_theta    =   0.01;
%set priors on parameters
prior_rho1_theta = [1,0.85,0.1]; %1th column is the shape; 2nd and 3rd are parameters used to compute density 
prior_rho2_theta = [1,0.1,0.1]; 
prior_std1_theta = [2,0.01,2]; 
prior_std2_theta = [2,0.00005,2];


rho1_chii      =   0.995374285090071 ; %0.99436;
rho2_chii      =   0;
p_chii         =   0;
std1_chii      =   0.027120167106938 ;
std2_chii      =   0.163;
%set priors on parameters
prior_rho1_chii = [1,0.5,0.2]; %1th column is the shape; 2nd and 3rd are parameters used to compute density 
prior_rho2_chii = [1,0.1,0.1]; 
prior_std1_chii = [2,0.001,5]; %[2,0.01,5]; 
%prior_std1_chii = [2,0.00361181157857,5]; 
prior_std2_chii = [2,0.00005,2];


rho1_taul     =   0.9;
rho2_taul     =   0;
p_taul        =   0;
std1_taul     =   0.01;
std2_taul     =   0.01;
%set priors on parameters
prior_rho1_taul = [1,0.85,0.01]; %1th column is the shape; 2nd and 3rd are parameters used to compute density 
prior_rho2_taul = [1,0.1,0.1]; 
prior_std1_taul = [2,0.01,2]; 
prior_std2_taul = [2,0.00005,2];


rho1_tauk     =   0.9;
rho2_tauk     =   0;
p_tauk        =   0; 
std1_tauk     =   0.01; %0.627;
std2_tauk     =   0.01;
%set priors on parameters
prior_rho1_tauk = [1,0.85,0.01]; %1th column is the shape; 2nd and 3rd are parameters used to compute density 
prior_rho2_tauk = [1,0.1,0.1]; 
prior_std1_tauk = [2,0.01,2]; 
prior_std2_tauk = [2,0.00005,2];


rho1_zeta     =   0.;%0.918;
rho2_zeta     =   0;
p_zeta        =   0;
std1_zeta     =   0.0129;
std2_zeta     =   0.1;
%set priors on parameters
prior_rho1_zeta = [1,0.5,0.2]; %1th column is the shape; 2nd and 3rd are parameters used to compute density 
prior_rho2_zeta = [1,0.1,0.1]; 
prior_std1_zeta = [2,0.001,5]; %prior_stddzeta1 = [2,0.002,2];
prior_std2_zeta = [2,0.00005,2];


rho1_g        =   0.991172046079021;
rho2_g        =   0;
p_g           =   0;
std1_g        =   0.012239657743047;
std2_g        =   0.0;
%set priors on parameters
prior_rho1_g = [1,0.5,0.2]; %[1,0.5,0.2];%% %1th column is the shape; 2nd and 3rd are parameters used to compute density 
prior_rho2_g = [1,0.1,0.1]; 
prior_std1_g = [2,0.01,5]; %prior_stddg1 = [2,0.001,5];
prior_std2_g = [2,0.00005,2];


rho1_v        =   0.9;%0.9;
rho2_v        =   0;
p_v           =   0;
std1_v        =   0.1;
std2_v        =   0.1; %0.36;
%set priors on parameters
prior_rho1_v = [1,0.85,0.1]; %1th column is the shape; 2nd and 3rd are parameters used to compute density 
prior_rho2_v = [1,0.1,0.1]; 
prior_std1_v = [6,0.01,4]; 
prior_std2_v = [2,0.00005,2];


rho1_taud     =   0.923;
rho2_taud     =   0;
p_taud        =   0;
std1_taud     =   0.01;
std2_taud     =   0.01;
%set priors on parameters
prior_rho1_taud = [1,0.85,0.1]; %1th column is the shape; 2nd and 3rd are parameters used to compute density 
prior_rho2_taud = [1,0.1,0.1]; 
prior_std1_taud = [2,0.1,2]; 
prior_std2_taud = [2,0.00005,2];


rho1_muzstar      =   0.069641371452839;
rho2_muzstar      =   0;
p_muzstar         =   0;
std1_muzstar      =   0.004713707844176 ;%.01/(1-alpha);%set this to zero if the shock is to be realized
std2_muzstar      =   .01/(1-alpha);
%set priors on parameters
prior_rho1_muzstar = [1,0.5,0.2]; %1th column is the shape; 2nd and 3rd are parameters used to compute density 
prior_rho2_muzstar = [1,0.1,0.1]; 
prior_std1_muzstar = [2,0.001,5]; %prior_stddmuz1 = [2,0.01,5]; 
prior_std2_muzstar = [2,0.025,2];


rho1_gamma    =   0;%0.624805877163558;
rho2_gamma    =   0;
p_gamma       =   6; %6;
std1_gamma    =   0.011460590057404;
std2_gamma    =   0.010978310068972;
%set priors on parameters
prior_rho1_gamma = [1,0.5,0.025]; %[1,0.5,0.05]; % %1th column is the shape; 2nd and 3rd are parameters used to compute density 
prior_rho2_gamma = [1,0.1,0.1]; 
prior_std1_gamma = [2,0.001,5]; %prior_stddgamma1 = [2,0.01,5];
%prior_std1_gamma = [2,0.04521029802953,5];  
prior_std2_gamma = [2,0.001,5];


rho1_epsil      =   0.950759691391667;
rho2_epsil      =   0;
p_epsil         =   0;
std1_epsil      =   0;%0.003904241030598 ;%set this to zero if you want the shock to be realized
std2_epsil      =   0.01; %0.00523;%0.00523;%0.01; %0.00253;
%set priors on parameters
prior_rho1_epsil = [1,0.5,0.2]; %1th column is the shape; 2nd and 3rd are parameters used to compute density 
prior_rho2_epsil = [1,0.1,0.1]; 
prior_std1_epsil = [2,0.001,5]; %prior_stddeps1 = [2,0.01,5]; 
prior_std2_epsil = [2,0.01,5];


if Taylor == 0
    rho1_xp    =  0.3; %monetary policy shock
    rho2_xp    =  0;
    p_xp      =  0;
    std1_xp    =  0.334;
    std2_xp    =  0.11;
    %set priors on parameters
    prior_rho1_xp = [1,0.85,0.1]; %1th column is the shape; 2nd and 3rd are parameters used to compute density
    prior_rho2_xp = [1,0.1,0.1];
    prior_std1_xp = [2,0.00005,2];
    prior_std2_xp = [2,0.00005,2];
end
if Taylor == 1 | Taylor == 2
    rho1_xp    =   0;   %monetary policy shock
    rho2_xp    =   0;
    p_xp       =   0;
    std1_xp     =  0.514882490955154;  %0.57;
    std2_xp     =   0;
    %set priors on parameters
    prior_rho1_xp = [1,0.1,0.05]; %1th column is the shape; 2nd and 3rd are parameters used to compute density
    prior_rho2_xp = [1,0.85,0.1];
    prior_std1_xp = [2,0.25,10]; %prior_stddp1 = [2,0.25,5];
    prior_std2_xp = [2,0.10,5];
end

rho1_tauc     =   0.9;     %0.9;%consumption tax rate
rho2_tauc     =   0;
p_tauc        =   0;
std1_tauc     =   0.104;
std2_tauc     =   0.01;
%set priors on parameters
prior_rho1_tauc = [1,0.85,0.01]; %1th column is the shape; 2nd and 3rd are parameters used to compute density 
prior_rho2_tauc = [1,0.1,0.1]; 
prior_std1_tauc = [2,0.01,2]; 
prior_std2_tauc = [2,0.00005,2];


rho1_sigma      =   0.706583451071793 ;
rho2_sigma      =   0;
p_sigma         =   0;
std1_sigma      =   0.067290653574299;
std2_sigma      =   0.;
%set priors on parameters
prior_rho1_sigma = [1,0.5,0.2]; %1th column is the shape; 2nd and 3rd are parameters used to compute density 
prior_rho2_sigma = [1,0.1,0.1]; 
prior_std1_sigma = [2,0.001,5]; %prior_stddsig1 = [2,0.01,5]; 
prior_std2_sigma = [2,0.01,5];


rho1_zetac    =   0.903982700145730;
rho2_zetac    =   0;
p_zetac       =   0;
std1_zetac    =   0.014331474344241;
std2_zetac    =   0.001;
%set priors on parameters
prior_rho1_zetac = [1,0.5,0.2]; %[1,0.5,0.2];%1th column is the shape; 2nd and 3rd are parameters used to compute density 
prior_rho2_zetac = [1,0.1,0.1]; 
prior_std1_zetac = [2,0.001,5]; %prior_stddzetac1 = [2,0.01,5]; 
prior_std2_zetac = [2,0.00005,2];


rho1_zetai    =   0.523690057765789; %0.55174;
rho2_zetai    =   0;
p_zetai       =   0;
std1_zetai    =   0.018667587827715;
std2_zetai    =   0.001;
%set priors on parameters
prior_rho1_zetai = [1,0.5,0.025]; %1th column is the shape; 2nd and 3rd are parameters used to compute density 
prior_rho2_zetai = [1,0.1,0.1]; 
prior_std1_zetai = [2,0.001,5]; %prior_stddzetai1 = [2,0.01,5];
prior_std2_zetai = [2,0.00005,2];


rho1_tauo    =   0.940838360883456;
rho2_tauo    =   0;
p_tauo       =   0;
std1_tauo    =   0.151309443111743 ;
std2_tauo    =   0.001;
%set priors on parameters
prior_rho1_tauo = [1,0.5,0.2]; %1th column is the shape; 2nd and 3rd are parameters used to compute density 
prior_rho2_tauo = [1,0.1,0.1]; 
prior_std1_tauo = [2,0.01,5]; %prior_stddtauo1 = [2,0.1,5];
prior_std2_tauo = [2,0.00005,2];


rho1_term    =   0.941493129835847;
rho2_term    =   0;
p_term       =   0;
std1_term    =   0.002780590945243 ;
std2_term    =   0.00;
%set priors on parameters
prior_rho1_term = [1,0.5,0.2]; %1th column is the shape; 2nd and 3rd are parameters used to compute density 
prior_rho2_term = [1,0.1,0.1]; 
prior_std1_term = [2,0.01,5]; %[2,0.001,5];   
prior_std2_term = [2,0.00005,2];


%set the measurement error stdd, Vmeas
Vmeas = 0.001*ones(1,length(tauvar)); %0.01
abc = [1:20];
Vmeas(abc(tauvar==1)) = 0.00899*2;%0.00895;%  0.00804;%stocks
Vmeas(abc(tauvar==2)) = 0.00019/2;%0.00019/2; %0.00046; %on inflation
Vmeas(abc(tauvar==3)) = 0.00145*2;%0.00179891804847; %0.00201; %on hours
Vmeas(abc(tauvar==4)) = 0.00067*2;%0.00074; %on credit growth
Vmeas(abc(tauvar==5)) = 0.00037/2;%0.00065506096447; %0.00061; %on GDP
Vmeas(abc(tauvar==6)) = 0.00029*2;%0.00044727104021; %0.00044; %on wages
Vmeas(abc(tauvar==7)) = 0.00162/2;%0.00204603498568; %0.00195; %on investment
Vmeas(abc(tauvar==8)) = 0.00098*2;%0.00136627619103; %0.00108; %on M1
Vmeas(abc(tauvar==9)) = 0.00049*2;%0.00049714607675; %0.00052; %on M3
m3_m1 = 0;
if m3_m1 == 1;
   Vmeas(abc(tauvar==9)) = 0.00059*2;%0.00049714607675; %0.00052; %on M3
end
Vmeas(abc(tauvar==10)) = 0.00040/2;%0.00047757807869; %0.00051; %on consumption
Vmeas(abc(tauvar==11)) = 0.00010*2;%0.00012947850218; %0.00014; %on premium
Vmeas(abc(tauvar==12)) = 0.00015*2;%0.00022325190054; %0.00026; %on spread1
Vmeas(abc(tauvar==13)) = 0.00023*2;%0.00008*2; on Ra
Vmeas(abc(tauvar==14)) = 0.00023/2;%0.00030715445372; %0.00082; %on Re
Vmeas(abc(tauvar==16)) = 0.00188;%0.00044; %gov.consumption
Vmeas(abc(tauvar==17)) = 0.00036/2;%0.00028874169301; %0.00032; %on investment price
Vmeas(abc(tauvar==18)) = 0.01391;%0.01479717882867; %0.01439; %on price of oil
Vmeas(abc(tauvar==19)) = 0.0001;%0.00020; %same as M1
Vmeas(abc(tauvar==20)) = 0.0001;%0.00020; %same as M1

Vmeas=Vmeas*0;

%over last 10 years
prior_1 = [6,0.00899*1.25,5]; %WARNING!!! CHANGED FROM: prior_1 = [6,0.00899*1.5,5];
prior_2 = [6,0.00019/2,5];%WARNING!!! CHANGED FROM: prior_2 = [6,0.00019/2,5];
prior_3 = [6,0.00145*1.25,5];%WARNING!!! CHANGED FROM: prior_3 = [6,0.00145*1.5,5];
prior_4 = [6,0.00067*1.25,5];%WARNING!!! CHANGED FROM: prior_4 = [6,0.00067*1.5,5];
prior_5 = [6,0.00037/2,5]; %WARNING!!! CHANGED FROM: prior_5 = [6,0.00037/2,5];
prior_6 = [6,0.00029*1.25,5]; %WARNING!!! CHANGED FROM: prior_6 = [6,0.00029*1,5];
prior_7 = [6,0.00162/2,5];%WARNING!!! CHANGED FROM: prior_7 = [6,0.00162/2,5];
prior_8 = [6,0.00098*1.25,5]; %WARNING!!! CHANGED FROM: prior_8 = [6,0.00098*1.5,5];
prior_9 = [6,0.00049*1.25,5]; %WARNING!!! CHANGED FROM: prior_9 = [6,0.00049*1.5,5];
m3_m1 = 0;
if m3_m1 == 1;
   prior_9 = [6,0.00059*1.25,5]; %%on M3
end
prior_10 = [6,0.00040/2,5];%WARNING!!! CHANGED FROM: prior_10 = [6,0.00040/2,5];
prior_11 = [6,0.00010*1.25,5]; %WARNING!!! CHANGED FROM: prior_11 = [6,0.00010*1,5];
prior_12 = [6,0.00015*1.25,5];%WARNING!!! CHANGED FROM: prior_12 = [6,0.00015*1.5,5];
prior_13 = [6,0.00023*1.25,5];%%WARNING!!!! The true meas.error on Ra is 0.00008!
prior_14 = [6,0.00023/2,5]; %WARNING!!! CHANGED FROM: prior_14 = [6,0.00023/2,5];
prior_15 = [6,0.00144,5];
prior_16 = [6,0.00188,5];
prior_17 = [6,0.00036/2,5]; %WARNING!!! CHANGED FROM: prior_17 = [6,0.00036/2,5];
prior_18 = [6,0.01391*1.25,5];%WARNING!!! CHANGED FROM: prior_12 = [6,0.01391,5];
prior_19 = [6,0.0001,5];
prior_20 = [6,0.01,5];

%monetary responses to shocks
% if Taylor == 0
%     phif = -0.01;
%     phitau = .01;
%     phipsil = .01;
%     phipsik = .01;
%     phiksi = 0.01;
%     phixb = .01;
%     phiup = .01;
%     phitheta = 0;
%     phichii = 0;
%     phitaul = .01;
%     phitauk = .01;
%     phizeta = .01;
%     phig = -0.232;
%     phiv = 0;%-0.078;
%     phitauD = .01;
%     phimuz = 150;%300;%150;
%     phigamma = .01;
%     phieps = 0;%-0.982;
%     phitauC = .01;
%     phisig = 0;%0.096;
% elseif Taylor == 1 | Taylor ==2
%     phif = 0;
%     phitau = 0;
%     phipsil = 0;
%     phipsik = 0;
%     phiksi = 0;
%     phixb = 0;
%     phiup = 0;
%     phitheta = 0;
%     phichii = 0;
%     phitaul = 0;
%     phitauk = 0;
%     phizeta = 0;
%     phig = 0;
%     phiv = 0;
%     phitauD = 0;
%     phimuz = 0;
%     phigamma = 0;
%     phieps = 0;
%     phitauC = 0;
%     phisig = 0;
% end

