%this program writes the table that reports the modes and posterior standard
%standard deviations for the CMR model.
[A] = getstddev;



fid = fopen('tabular.tex','w');
fprintf(fid,'\\documentclass{article} \n');
fprintf(fid,'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% \n');
fprintf(fid,'%%TCIDATA{OutputFilter=LATEX.DLL} \n');
fprintf(fid,'%%TCIDATA{Created=Monday, October 10, 2005 16:33:03} \n');
fprintf(fid,'%%TCIDATA{LastRevised=Thu Mar 27 17:07:50 2008} \n');
fprintf(fid,'%%TCIDATA{<META NAME="GraphicsSave" CONTENT="32">} \n');
fprintf(fid,'%%TCIDATA{<META NAME="DocumentShell" CONTENT="Standard LaTeX\\Blank - Standard LaTeX Article">} \n');
fprintf(fid,'%%TCIDATA{CSTFile=article.cst} \n');
fprintf(fid,'%%TCIDATA{PageSetup=14,14,14,14,0} \n');
fprintf(fid,'%%TCIDATA{AllPages= \n');
fprintf(fid,'%%H=36 \n');
fprintf(fid,'%%F=36 \n');
fprintf(fid,'%%} \n');


fprintf(fid,'\\newtheorem{theorem}{Theorem} \n');
fprintf(fid,'\\newtheorem{acknowledgement}[theorem]{Acknowledgement} \n');
fprintf(fid,'\\newtheorem{algorithm}[theorem]{Algorithm} \n');
fprintf(fid,'\\newtheorem{axiom}[theorem]{Axiom} \n');
fprintf(fid,'\\newtheorem{case}[theorem]{Case} \n');
fprintf(fid,'\\newtheorem{claim}[theorem]{Claim} \n');
fprintf(fid,'\\newtheorem{conclusion}[theorem]{Conclusion} \n');
fprintf(fid,'\\newtheorem{condition}[theorem]{Condition} \n');
fprintf(fid,'\\newtheorem{conjecture}[theorem]{Conjecture} \n');
fprintf(fid,'\\newtheorem{corollary}[theorem]{Corollary} \n');
fprintf(fid,'\\newtheorem{criterion}[theorem]{Criterion} \n');
fprintf(fid,'\\newtheorem{definition}[theorem]{Definition} \n');
fprintf(fid,'\\newtheorem{example}[theorem]{Example} \n');
fprintf(fid,'\\newtheorem{exercise}[theorem]{Exercise} \n');
fprintf(fid,'\\newtheorem{lemma}[theorem]{Lemma} \n');
fprintf(fid,'\\newtheorem{notation}[theorem]{Notation} \n');
fprintf(fid,'\\newtheorem{problem}[theorem]{Problem} \n');
fprintf(fid,'\\newtheorem{proposition}[theorem]{Proposition} \n');
fprintf(fid,'\\newtheorem{remark}[theorem]{Remark} \n');
fprintf(fid,'\\newtheorem{solution}[theorem]{Solution} \n');
fprintf(fid,'\\newtheorem{summary}[theorem]{Summary} \n');
fprintf(fid,'\\newenvironment{proof}[1][Proof]{\\noindent\\textbf{#1.} }{\\ \\rule{0.5em}{0.5em}} \n');
fprintf(fid,'\\input{tcilatex} \n');

fprintf(fid,'\\begin{document} \n');


fprintf(fid,' Table 4. Full Model Parameter Estimates: Euro area and US\n');

fprintf(fid,'\\begin{center}\n');
fprintf(fid,'\\begin{tabular}{lllll|lll|lll}\n');
fprintf(fid,'&  &  & $\n');
fprintf(fid,'\\begin{array}{c}\n');
fprintf(fid,'\\text{{\\small Prior }}\n');
fprintf(fid,'\\end{array}\n');
fprintf(fid,'$ &  &  & $\n');
fprintf(fid,'\\begin{array}{c}\n');
fprintf(fid,'\\text{{\\small Posterior}} \\\\ \n');
fprintf(fid,'\\multicolumn{1}{l}{\\text{{\\small Euro area}}}\n');
fprintf(fid,'\\end{array}\n');
fprintf(fid,'$ &  &  & $\n');
fprintf(fid,'\\begin{array}{c}\n');
fprintf(fid,'\\text{{\\small Posterior}} \\\\ \n');
fprintf(fid,'\\text{{\\small US}}\n');
fprintf(fid,'\\end{array}\n');
fprintf(fid,'$ &  \\\\ \n');
fprintf(fid,'&  & \\multicolumn{1}{c}{$\n');
fprintf(fid,'\\begin{array}{c}\n');
fprintf(fid,'\\text{{\\small Type}}\n');
fprintf(fid,'\\end{array}\n');
fprintf(fid,'$} & $\n');
fprintf(fid,'\\begin{array}{c}\n');
fprintf(fid,'\\text{{\\small Mode}}\n');
fprintf(fid,'\\end{array}\n');
fprintf(fid,'$ & $\n');
fprintf(fid,'\\begin{array}{c}\n');
fprintf(fid,'\\text{{\\small Std. dev.}}\n');
fprintf(fid,'\\end{array}\n');
fprintf(fid,'$ & $\n');
fprintf(fid,'\\begin{array}{c}\n');
fprintf(fid,'\\text{{\\small Mode}}\n');
fprintf(fid,'\\end{array}\n');
fprintf(fid,'$ & $\n');
fprintf(fid,'\\begin{array}{c}\n');
fprintf(fid,'\\text{{\\small Std. dev.}} \\\\ \n');
fprintf(fid,'\\text{{\\small (Hess.)}}\n');
fprintf(fid,'\\end{array}\n');
fprintf(fid,'$ & $\n');
fprintf(fid,'\\begin{array}{c}\n');
fprintf(fid,'\\text{{\\small 90\\%%}} \\\\ \n');
fprintf(fid,'\\text{{\\small Prob. Interval}}\n');
fprintf(fid,'\\end{array}\n');
fprintf(fid,'$ & $\n');
fprintf(fid,'\\begin{array}{c}\n');
fprintf(fid,'\\text{{\\small Mode}}\n');
fprintf(fid,'\\end{array}\n');
fprintf(fid,'$ & $\n');
fprintf(fid,'\\begin{array}{c}\n');
fprintf(fid,'\\text{{\\small Std. dev.}} \\\\ \n');
fprintf(fid,'\\text{{\\small (Hess.)}}\n');
fprintf(fid,'\\end{array}\n');
fprintf(fid,'$ & $\n');
fprintf(fid,'\\begin{array}{c}\n');
fprintf(fid,'\\text{{\\small 90\\%%}} \\\\ \n');
fprintf(fid,'\\text{{\\small Prob. Interval}}\n');
fprintf(fid,'\\end{array}\n');
fprintf(fid,'$ \\\\ \n');

fprintf(fid,'$\\xi _{p}$ & {\\small Calvo prices} & {\\small Beta} & $\n');
fprintf(fid,'\\begin{array}{c}\n');
fprintf(fid,'\\text{{\\small 0.75}}^{\\ast } \\\\ \n');
fprintf(fid,'\\text{{\\small 0.375}}\n');
fprintf(fid,'\\end{array}\n');
fprintf(fid,'$ & {\\small 0.05} & {\\small %6.3f} & {\\small %6.3f} & {\\small %6.3f-%6.3f} &{\\small %6.3f}  & {\\small %6.3f} & {\\small %6.3f-%6.3f} \\\\ \n',A(1,:));

fprintf(fid,'$\\xi _{w}$ & {\\small Calvo wages} & {\\small Beta} & $\n');
fprintf(fid,'\\begin{array}{c}\n');
fprintf(fid,'\\text{{\\small 0.75}}^{\\ast } \\\\ \n');
fprintf(fid,'\\text{{\\small 0.375}}\n');
fprintf(fid,'\\end{array}\n');
fprintf(fid,'$ & {\\small 0.1} & {\\small %6.3f} & {\\small %6.3f} & {\\small %6.3f-%6.3f} &{\\small %6.3f}  & {\\small %6.3f} & {\\small %6.3f-%6.3f} \\\\ \n',A(2,:));


fprintf(fid,'$ H'''' $ & {\\small Curvature on currency demand} & {\\small Normal} & \n');
fprintf(fid,'{\\small 2} & {\\small 2} & {\\small %6.3f} & {\\small %6.3f} & {\\small %6.3f-%6.3f} &{\\small %6.3f}  & {\\small %6.3f} & {\\small %6.3f-%6.3f} \\\\ \n',A(3,:));


fprintf(fid,'$1-\\iota $ & {\\small Weight on lagged inflation: prices} & {\\small Beta} & \n');
fprintf(fid,'{\\small 0.5} & {\\small 0.15} & {\\small %6.3f} & {\\small %6.3f} & {\\small %6.3f-%6.3f} &{\\small %6.3f}  & {\\small %6.3f} & {\\small %6.3f-%6.3f} \\\\ \n',A(4,:));

fprintf(fid,'$1-\\iota _{w}$ & {\\small Weight on lagged inflation: wages} & {\\small Beta} & \n');
fprintf(fid,'{\\small 0.5} & {\\small 0.15} & {\\small %6.3f} & {\\small %6.3f} & {\\small %6.3f-%6.3f} &{\\small %6.3f}  & {\\small %6.3f} & {\\small %6.3f-%6.3f} \\\\ \n',A(5,:));
fprintf(fid,'$\\vartheta $ & {\\small Weight on technology growth: wages} & {\\small Beta} & \n');
fprintf(fid,'{\\small 0.5} & {\\small 0.15} & {\\small %6.3f} & {\\small %6.3f} & {\\small %6.3f-%6.3f} &{\\small %6.3f}  & {\\small %6.3f} & {\\small %6.3f-%6.3f} \\\\ \n',A(6,:));
fprintf(fid,'$S^{\\prime \\prime }$ & {\\small Investment adjust. cost} & {\\small Normal} & \n');
fprintf(fid,'{\\small 10} & {\\small 5} & {\\small %6.3f} & {\\small %6.3f} & {\\small %6.3f-%6.3f} &{\\small %6.3f}  & {\\small %6.3f} & {\\small %6.3f-%6.3f} \\\\ \n',A(7,:));
fprintf(fid,'$\\sigma _{a}$ & {\\small Capacity utilization} & {\\small Gamma} & {\\small 6}\n');
fprintf(fid,'& {\\small 5} & {\\small %6.3f} & {\\small %6.3f} & {\\small %6.3f-%6.3f} &{\\small %6.3f}  & {\\small %6.3f} & {\\small %6.3f-%6.3f} \\\\ \n',A(8,:));
fprintf(fid,'$\\alpha _{\\pi }$ & {\\small Weight on infl. in Taylor rule} & {\\small Normal}\n');
fprintf(fid,'& {\\small 1.75} & {\\small 0.1} & {\\small %6.3f} & {\\small %6.3f} & {\\small %6.3f-%6.3f} &{\\small %6.3f}  & {\\small %6.3f} & {\\small %6.3f-%6.3f} \\\\ \n',A(9,:));
fprintf(fid,'$\\alpha _{y}$ & {\\small Weight on outp. growth in Taylor rule} & {\\small Normal} & {\\small 0.25} & {\\small 0.1} & {\\small %6.3f} & {\\small %6.3f} & {\\small %6.3f-%6.3f} &{\\small %6.3f}  & {\\small %6.3f} & {\\small %6.3f-%6.3f} \\\\ \n',A(10,:));

fprintf(fid,'$\\alpha _{c}$ & {\\small Weight on credit growth in Taylor rule} & {\\small Normal} & {\\small 0.025} & {\\small 0.025} & {\\small %6.3f} & {\\small %6.3f} & {\\small %6.3f-%6.3f} &{\\small %6.3f}  & {\\small %6.3f} & {\\small %6.3f-%6.3f} \\\\ \n',A(11,:));

fprintf(fid,'$\\alpha _{d\\pi }$ & {\\small Weight on change in infl. in Taylor rule} & \n');
fprintf(fid,'{\\small Normal} & {\\small 0.3} & {\\small 0.1} & {\\small %6.3f} & {\\small %6.3f} & {\\small %6.3f-%6.3f} &{\\small %6.3f}  & {\\small %6.3f} & {\\small %6.3f-%6.3f} \\\\ \n',A(12,:));

fprintf(fid,'$\\rho_{i}$ & {\\small Coeff. on lagged interest rate}$^{\\ast \\ast }\n');
fprintf(fid,'$ & {\\small Normal} & {\\small 0.05} & {\\small 0.025} & {\\small %6.3f} & {\\small %6.3f} & {\\small %6.3f-%6.3f} &{\\small %6.3f}  & {\\small %6.3f} & {\\small %6.3f-%6.3f} \\\\ \n',A(13,:));


fprintf(fid,'$\\rho $ & {\\small Banking technol. shock (}$x_{t}^{b}${\\small )} & {\\small %%\n');
fprintf(fid,'Beta} & {\\small 0.5} & {\\small 0.2} & {\\small %6.3f} & {\\small %6.3f} & {\\small %6.3f-%6.3f} &{\\small %6.3f}  & {\\small %6.3f} & {\\small %6.3f-%6.3f} \\\\ \n',A(14,:));

fprintf(fid,'$\\rho $ & {\\small Bank reserve demand shock (}$\\xi _{t}${\\small )} & {\\small %%\n');
fprintf(fid,'Beta} & {\\small 0.5} & {\\small 0.2} & {\\small %6.3f} & {\\small %6.3f} & {\\small %6.3f-%6.3f} &{\\small %6.3f}  & {\\small %6.3f} & {\\small %6.3f-%6.3f} \\\\ \n',A(15,:));

fprintf(fid,'$\\rho $ & {\\small Term premium shock (}$\\sigma _{t}^{\\aleph }${\\small )} & \n');
fprintf(fid,'{\\small Beta} & {\\small 0.5} & {\\small 0.2} & {\\small %6.3f} & {\\small %6.3f} & {\\small %6.3f-%6.3f} &{\\small %6.3f}  & {\\small %6.3f} & {\\small %6.3f-%6.3f} \\\\ \n',A(16,:));
fprintf(fid,'$\\rho $ & {\\small Investm. specific shock (}$\\mu _{\\Upsilon ,t}${\\small )} & \n');
fprintf(fid,'{\\small Beta} & {\\small 0.5} & {\\small 0.2} & {\\small %6.3f} & {\\small %6.3f} & {\\small %6.3f-%6.3f} &{\\small %6.3f}  & {\\small %6.3f} & {\\small %6.3f-%6.3f} \\\\ \n',A(17,:));
fprintf(fid,'$\\rho $ & {\\small Money demand shock (}$\\chi _{t}${\\small )} & {\\small Beta}\n');
fprintf(fid,'& {\\small 0.5} & {\\small 0.2} & {\\small %6.3f} & {\\small %6.3f} & {\\small %6.3f-%6.3f} &{\\small %6.3f}  & {\\small %6.3f} & {\\small %6.3f-%6.3f} \\\\ \n',A(18,:));
fprintf(fid,'$\\rho $ & {\\small Government consumption shock (}$g_{t}${\\small )} & {\\small %%\n');
fprintf(fid,'Beta} & {\\small 0.5} & {\\small 0.2} & {\\small %6.3f} & {\\small %6.3f} & {\\small %6.3f-%6.3f} &{\\small %6.3f}  & {\\small %6.3f} & {\\small %6.3f-%6.3f} \\\\ \n',A(19,:));
fprintf(fid,'$\\rho $ & {\\small Persistent product. shock (}$\\mu _{t}^{\\ast }${\\small )} & \n');
fprintf(fid,'{\\small Beta} & {\\small 0.5} & {\\small 0.2} & {\\small %6.3f} & {\\small %6.3f} & {\\small %6.3f-%6.3f} &{\\small %6.3f}  & {\\small %6.3f} & {\\small %6.3f-%6.3f} \\\\ \n',A(20,:));
fprintf(fid,'$\\rho $ & {\\small Transitory product. shock (}$\\epsilon _{t}${\\small )} & \n');
fprintf(fid,'{\\small Beta} & {\\small 0.5} & {\\small 0.2} & {\\small %6.3f} & {\\small %6.3f} & {\\small %6.3f-%6.3f} &{\\small %6.3f}  & {\\small %6.3f} & {\\small %6.3f-%6.3f} \\\\ \n',A(21,:));
fprintf(fid,'$\\rho $ & {\\small Riskiness shock (}$\\sigma _{t}${\\small )} & {\\small Beta}\n');
fprintf(fid,'& {\\small 0.5} & {\\small 0.2} & {\\small %6.3f} & {\\small %6.3f} & {\\small %6.3f-%6.3f} &{\\small %6.3f}  & {\\small %6.3f} & {\\small %6.3f-%6.3f} \\\\ \n',A(22,:));
fprintf(fid,'$\\rho $ & {\\small Consump. prefer. shock (}$\\zeta _{c,t}${\\small )} & \n');
fprintf(fid,'{\\small Beta} & {\\small 0.5} & {\\small 0.2} & {\\small %6.3f} & {\\small %6.3f} & {\\small %6.3f-%6.3f} &{\\small %6.3f}  & {\\small %6.3f} & {\\small %6.3f-%6.3f} \\\\ \n',A(23,:));
fprintf(fid,'$\\rho $ & {\\small Margin. effic. of invest. shock (}$\\zeta _{i,t}${\\small )}\n');
fprintf(fid,'& {\\small Beta} & {\\small 0.5} & {\\small 0.1} & {\\small %6.3f} & {\\small %6.3f} & {\\small %6.3f-%6.3f} &{\\small %6.3f}  & {\\small %6.3f} & {\\small %6.3f-%6.3f} \\\\ \n',A(24,:));
fprintf(fid,'$\\rho $ & {\\small Oil price shock (}$\\tau _{t}^{oil}${\\small )} & {\\small %%\n');
fprintf(fid,'Beta} & {\\small 0.5} & {\\small 0.2} & {\\small %6.3f} & {\\small %6.3f} & {\\small %6.3f-%6.3f} &{\\small %6.3f}  & {\\small %6.3f} & {\\small %6.3f-%6.3f} \\\\ \n',A(25,:));
fprintf(fid,'$\\rho $ & {\\small Price mark-up shock (}$\\lambda _{f,t}${\\small )} & {\\small %%\n');
fprintf(fid,'Beta} & {\\small 0.5} & {\\small 0.2} & {\\small %6.3f} & {\\small %6.3f} & {\\small %6.3f-%6.3f} &{\\small %6.3f}  & {\\small %6.3f} & {\\small %6.3f-%6.3f} \\\\ \n',A(26,:));
fprintf(fid,'\\end{tabular}\n');
fprintf(fid,'\\end{center}\n');

fprintf(fid,'$^{\\ast }${\\small \\ The prior mode is 0.75 for the EA and 0.375 for the US.}\n');

fprintf(fid,'$^{\\ast \\ast }${\\small Response to real credit growth is set to zero for the\n');
fprintf(fid,'US. \\newpage }\n');

fprintf(fid,'Table 4, continued\n');

fprintf(fid,'\\begin{tabular}{lllll|lll|lll}\n');
fprintf(fid,'&  &  & $\n');
fprintf(fid,'\\begin{array}{c}\n');
fprintf(fid,'\\text{{\\small Prior }}\n');
fprintf(fid,'\\end{array}\n');
fprintf(fid,'$ &  &  & $\n');
fprintf(fid,'\\begin{array}{c}\n');
fprintf(fid,'\\text{{\\small Posterior}} \\\\ \n');
fprintf(fid,'\\multicolumn{1}{l}{\\text{{\\small Euro area}}}\n');
fprintf(fid,'\\end{array}\n');
fprintf(fid,'$ &  &  & $\n');
fprintf(fid,'\\begin{array}{c}\n');
fprintf(fid,'\\text{{\\small Posterior }} \\\\ \n');
fprintf(fid,'\\text{{\\small US}}\n');
fprintf(fid,'\\end{array}\n');
fprintf(fid,'$ &  \\\\ \n');
fprintf(fid,'&  & \\multicolumn{1}{c}{$\n');
fprintf(fid,'\\begin{array}{c}\n');
fprintf(fid,'\\text{{\\small Type}}\n');
fprintf(fid,'\\end{array}\n');
fprintf(fid,'$} & $\n');
fprintf(fid,'\\begin{array}{c}\n');
fprintf(fid,'\\text{{\\small Mode}}\n');
fprintf(fid,'\\end{array}\n');
fprintf(fid,'$ & $\n');
fprintf(fid,'\\begin{array}{c}\n');
fprintf(fid,'\\text{{\\small Df.}}\n');
fprintf(fid,'\\end{array}\n');
fprintf(fid,'$ & $\n');
fprintf(fid,'\\begin{array}{c}\n');
fprintf(fid,'\\text{{\\small Mode}}\n');
fprintf(fid,'\\end{array}\n');
fprintf(fid,'$ & $\n');
fprintf(fid,'\\begin{array}{c}\n');
fprintf(fid,'\\text{{\\small Std. dev.}} \\\\ \n');
fprintf(fid,'\\text{{\\small (Hess.)}}\n');
fprintf(fid,'\\end{array}\n');
fprintf(fid,'$ & $\n');
fprintf(fid,'\\begin{array}{c}\n');
fprintf(fid,'\\text{{\\small 90\\%%}} \\\\ \n');
fprintf(fid,'\\text{{\\small Prob. Interval}}\n');
fprintf(fid,'\\end{array}\n');
fprintf(fid,'$ & $\n'); 
fprintf(fid,'\\begin{array}{c}\n');
fprintf(fid,'\\text{{\\small Mode}}\n');
fprintf(fid,'\\end{array}\n');
fprintf(fid,'$ & $\n');
fprintf(fid,'\\begin{array}{c}\n');
fprintf(fid,'\\text{{\\small Std. dev.}} \\\\ \n');
fprintf(fid,'\\text{{\\small (Hess.)}}\n');
fprintf(fid,'\\end{array}\n');
fprintf(fid,'$ & $\n');
fprintf(fid,'\\begin{array}{c}\n');
fprintf(fid,'\\text{{\\small 90\\%%}} \\\\ \n');
fprintf(fid,'\\text{{\\small Prob. Interval}}\n');
fprintf(fid,'\\end{array}\n');
fprintf(fid,'$ \\\\ \n');

fprintf(fid,'$\\sigma $ & {\\small Banking technol. shock (}$x_{t}^{b}${\\small )} & {\\small %%\n');
fprintf(fid,' Inv. Gamma} & {\\small 0.1} & {\\small 5 d} & {\\small %7.4f} & {\\small %7.4f} & {\\small %7.4f-%7.4f} &{\\small %7.4f}  & {\\small %7.4f} & {\\small %7.4f-%7.4f} \\\\ \n',A(27,:));

fprintf(fid,'$\\sigma $ & {\\small Bank reserve demand (}$\\xi _{t}${\\small )} & {\\small %%\n');
fprintf(fid,' Inv. Gamma} & {\\small 0.1} & {\\small 5 d} & {\\small %7.4f} & {\\small %7.4f} & {\\small %7.4f-%7.4f} &{\\small %7.4f}  & {\\small %7.4f} & {\\small %7.4f-%7.4f} \\\\ \n',A(28,:));

fprintf(fid,'$\\sigma $ & {\\small Term premium shock (}$\\sigma _{t}^{\\aleph }${\\small )} & \n');
fprintf(fid,'{\\small Inv. Gamma} & {\\small 0.1} & {\\small 5 d} & {\\small %7.4f} & {\\small %7.4f} & {\\small %7.4f-%7.4f} &{\\small %7.4f}  & {\\small %7.4f} & {\\small %7.4f-%7.4f} \\\\ \n',A(29,:));
fprintf(fid,'$\\sigma $ & {\\small Investm. specific shock (}$\\mu _{\\Upsilon ,t}${\\small )}\n');
fprintf(fid,'& {\\small Inv. Gamma} & {\\small 0.003} & {\\small 5 d} & {\\small %7.4f} & {\\small %7.4f} & {\\small %7.4f-%7.4f} &{\\small %7.4f}  & {\\small %7.4f} & {\\small %7.4f-%7.4f} \\\\ \n',A(30,:));
fprintf(fid,'$\\sigma $ & {\\small Money demand shock (}$\\chi _{t}${\\small )} & {\\small %%\n');
fprintf(fid,'Inv. Gamma} & {\\small 0.001} & {\\small 5 d} & {\\small %7.4f} & {\\small %7.4f} & {\\small %7.4f-%7.4f} &{\\small %7.4f}  & {\\small %7.4f} & {\\small %7.4f-%7.4f} \\\\ \n',A(31,:));
fprintf(fid,'$\\sigma $ & {\\small Government consumption shock (}$g_{t}${\\small )} & \n');
fprintf(fid,'{\\small Inv. Gamma} & {\\small 0.01} & {\\small 5 d} & {\\small %7.4f} & {\\small %7.4f} & {\\small %7.4f-%7.4f} &{\\small %7.4f}  & {\\small %7.4f} & {\\small %7.4f-%7.4f} \\\\ \n',A(32,:));
fprintf(fid,'$\\sigma $ & {\\small Persistent product. shock (}$\\mu _{t}^{\\ast }${\\small )}\n');
fprintf(fid,'& {\\small Inv. Gamma} & {\\small 0.001} & {\\small 5 d} & {\\small %7.4f} & {\\small %7.4f} & {\\small %7.4f-%7.4f} &{\\small %7.4f}  & {\\small %7.4f} & {\\small %7.4f-%7.4f} \\\\ \n',A(33,:));
fprintf(fid,'$\\sigma $ & {\\small Transitory product. shock (}$\\epsilon _{t}${\\small )} & \n');
fprintf(fid,'{\\small Inv. Gamma} & {\\small 0.001} & {\\small 5 d} & {\\small %7.4f} & {\\small %7.4f} & {\\small %7.4f-%7.4f} &{\\small %7.4f}  & {\\small %7.4f} & {\\small %7.4f-%7.4f} \\\\ \n',A(34,:));
fprintf(fid,'$\\sigma $ & {\\small Financial wealth shock (}$\\gamma _{t}${\\small )} & \n');
fprintf(fid,'{\\small Inv. Gamma} & {\\small 0.001} & {\\small 5 d} & {\\small %7.4f} & {\\small %7.4f} & {\\small %7.4f-%7.4f} &{\\small %7.4f}  & {\\small %7.4f} & {\\small %7.4f-%7.4f} \\\\ \n',A(35,:));

fprintf(fid,'$\\sigma $ & {\\small Riskiness shock (}$\\sigma _{t}${\\small )} & {\\small Inv.\n');
fprintf(fid,'Gamma} & {\\small 0.001} & {\\small 5 d} & {\\small %7.4f} & {\\small %7.4f} & {\\small %7.4f-%7.4f} &{\\small %7.4f}  & {\\small %7.4f} & {\\small %7.4f-%7.4f} \\\\ \n',A(36,:));

fprintf(fid,'$\\sigma $ & {\\small Signal, risk shock (}$\\sigma _{t}${\\small )} & {\\small Inv.\n');
fprintf(fid,'Gamma} & {\\small 0.001} & {\\small 5 d} & {\\small %7.4f} & {\\small %7.4f} & {\\small %7.4f-%7.4f} &{\\small %7.4f}  & {\\small %7.4f} & {\\small %7.4f-%7.4f} \\\\ \n',A(37,:));


fprintf(fid,'$\\sigma $ & {\\small Consump. prefer. shock (}$\\zeta _{c,t}${\\small )} & \n');
fprintf(fid,'{\\small Inv. Gamma} & {\\small 0.01} & {\\small 5 d} & {\\small %7.4f} & {\\small %7.4f} & {\\small %7.4f-%7.4f} &{\\small %7.4f}  & {\\small %7.4f} & {\\small %7.4f-%7.4f} \\\\ \n',A(38,:));
fprintf(fid,'$\\sigma $ & {\\small Margin. effic. of invest. shock (}$\\zeta _{i,t}${\\small )%%\n');
fprintf(fid,'} & {\\small Inv. Gamma} & {\\small 0.001} & {\\small 5 d} & {\\small %7.4f} & {\\small %7.4f} & {\\small %7.4f-%7.4f} &{\\small %7.4f}  & {\\small %7.4f} & {\\small %7.4f-%7.4f} \\\\ \n',A(39,:));
fprintf(fid,'$\\sigma $ & {\\small Oil price shock (}$\\tau _{t}^{oil}${\\small )} & {\\small %%\n');
fprintf(fid,'Inv. Gamma} & {\\small 0.01} & {\\small 5 d} & {\\small %7.4f} & {\\small %7.4f} & {\\small %7.4f-%7.4f} &{\\small %7.4f}  & {\\small %7.4f} & {\\small %7.4f-%7.4f} \\\\ \n',A(40,:));
fprintf(fid,'$\\sigma $ & {\\small Monetary policy shock (}$\\varepsilon _{t}${\\small )} & \n');
fprintf(fid,'{\\small Inv. Gamma} & $\\text{{\\small 0.25}}$ & {\\small 5 d} & {\\small %7.4f} & {\\small %7.4f} & {\\small %7.4f-%7.4f} &{\\small %7.4f}  & {\\small %7.4f} & {\\small %7.4f-%7.4f} \\\\ \n',A(41,:));
fprintf(fid,'$\\sigma $ & {\\small Price markup shock (}$\\lambda _{f,t}${\\small )} & \n');
fprintf(fid,'{\\small Inv. Gamma} & {\\small 0.0005} & {\\small 5 d} & {\\small %7.4f} & {\\small %7.4f} & {\\small %7.4f-%7.4f} &{\\small %7.4f}  & {\\small %7.4f} & {\\small %7.4f-%7.4f} \\\\ \n',A(42,:));
fprintf(fid,'\\end{tabular}\n');

fprintf(fid,'\\end{document}\n');
fclose(fid);