function [omega,G,F,Gamma,Gam_muG,Fprime,er] = ffindomeg(sig,mu,sp1)

oomega=.001:.001:1.4;
er=0;
[fu,ix,II]=help_omeg(sig,oomega,mu,sp1);

if ix > 1
    error('fatal (ffindomeg) multiple solutions')
end

if ix == 0
    %if it looks like there might be a zero at a higher level of omega, try looking there
    if (fu(end)-fu(end-1)) < 0
        oomega=1.4:.001:3;
        [fu,ix,II]=help_omeg(sig,oomega,mu,sp1);
    else
        omega=0;
        er=1;
        G=[];F=[];Gamma=[];Gam_muG=[];Fprime=[];
        return
    end
    if ix == 0
        omega=0;
        er=1;
        G=[];F=[];Gamma=[];Gam_muG=[];Fprime=[];
        return
    end
end

x=[oomega(II(1)-1) oomega(II(1))];
[xx,fval,exitflag] = fzero('findomeg',x,optimset,sig,mu,sp1);
if exitflag ~= 1 | abs(fval) > .1e-10 | abs(imag(xx)) > .1e-10
    error(' fatal (ffindomeg) failed to find a zero')
end
omega=xx;
[ff,G,F,Gamma,Gam_muG,Fprime]=findomeg(omega,sig,mu,sp1);
