function [Rk,omega,G,F,Gamma,Gam_muG,Fprime,k,n,c] = steadystate(R,sigma,mu,alpha,gamma,delta,z)

addpath euroarea_code -end
addpath micro_economics_of_bgg -end

RRk=R+.001:.001:1.1;
xRk=RRk(1);
[ff,sp1,omega,G,F,Gamma,Gam_muG,Fprime,k,n]=help_equil(xRk,R,sigma,mu,alpha,gamma,delta,z);
gg(1)=ff;
for ii = 2:length(RRk)
    xRk=RRk(ii);
    [ff,sp1,omega,G,F,Gamma,Gam_muG,Fprime,k,n]=help_equil(xRk,R,sigma,mu,alpha,gamma,delta,z);    
    gg(ii)=ff;
    if gg(ii)*gg(ii-1) < 0
        II=ii;
        break
    end
end
RRk_low=RRk(II-1);
RRk_high=RRk(II);
[x,fval,exitflag]=fzero('help_equil',[RRk_low RRk_high],optimset('Display','iter'),R,sigma,mu,alpha,gamma,delta,z);
if exitflag ~= 1 || abs(fval) > .1e-9
    error('fatal (bgg_steadystate) failed to find steady state')
end
Rk=x;
[ff,sp1,omega,G,F,Gamma,Gam_muG,Fprime,k,n]=help_equil(Rk,R,sigma,mu,alpha,gamma,delta,z); 
c=z*k^alpha-delta*k-mu*G*Rk*k;


